package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

public class ExternActivity extends ActionBarActivity
{
    protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_extern);                                                   // Layout starten

        Button button_start_ad = (Button) findViewById(R.id.extern_button_ad);                      // Buttonvariable für A/D-Wandler anlegen
		button_start_ad.setOnClickListener(new View.OnClickListener() {                             // Bei Knopfdruck Aktion ausführen
            public void onClick(View v) {
                Start(0);                                                                           // Wenn gedrückt, anderes Layout starten
            }
        });

        Button button_start_i2c = (Button) findViewById(R.id.extern_button_i2c);                    // Buttonvariable für I2C Interface anlegen
		button_start_i2c.setOnClickListener(new View.OnClickListener() {                            // Bei Knopfdruck Aktion ausführen
            public void onClick(View v) {
                Start(1);                                                                           // Wenn gedrückt, anderes Layout starten
            }
        });
	}

	private void Start(int Auswahl)                                                                 // Je nach Knopfdruck -> passendes Layout anlegen
	{
		Intent intent;
		switch(Auswahl)
		{
			case 0: intent = new Intent(this, ExternActivity_ADC.class);                            // ADC Activity anlegen
				startActivity(intent);                                                              // und starten
				break;

			case 1: intent = new Intent(this, ExternActivity_I2C.class);                            // I2C Activity anlegen
				startActivity(intent);                                                              // und starten
				break;
		}
	}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Menü anlegen
	{
		getMenuInflater().inflate(R.menu.menu_gross, menu);                                         // Menü mit zwei Buttons anlegen -> siehe xml-Datei
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())                                                                   // Bei Knopfdruck schauen welcher gedrückt wurde
		{
			case R.id.action_info:                                                                  // Infofenster anzeigen
				Info();
				return true;

			case R.id.action_beenden:                                                               // App beenden
				this.finish();
				Intent intent = new Intent(Intent.ACTION_MAIN);
				intent.addCategory(Intent.CATEGORY_HOME);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				startActivity(intent);
				return true;

			default:                                                                                // sonst nichts machen
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();                           // neue Infobox anlegen
		alertDialog.setTitle("INFO");                                                               // Infotitel einstellen
		alertDialog.setMessage(getString(R.string.menue_info_text));          // Text eintragen
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()                           // mit OK Button
		{public void onClick(DialogInterface dialog, int which) {}});                               // Wenn OK gedrückt wird, nichts machen, nur schließen
		alertDialog.show();                                                                         // Infodialog anzeigen
	}
}
