package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

public class ExternActivity_ADC extends ActionBarActivity
{
    private final int USBAccessoryWhat = 0;                                                         // für msg

    // Kommandos für die USB Kommunikation
    private final int AD_WANDLER_CONFIG         = (int)0xAC;                                        // für Typ
    private final int AD_WANDLER_READ           = (int)0xAD;                                        // für Typ
    private final int APP_CONNECT				= (int)0xFE;                                        // für Typ
    private final int APP_DISCONNECT			= (int)0xFF;                                        // für Typ

    // Portkommandos
    private final int AN_0 = (int)0;                                                                // für Port
    private final int AN_1 = (int)1;                                                                // für Port
    private final int AN_2 = (int)2;                                                                // für Port
    private final int AN_3 = (int)3;                                                                // für Port
    private final int AN_4 = (int)4;                                                                // für Port
    private final int AN_8 = (int)8;                                                                // für Port
    private final int AN_9 = (int)9;                                                                // für Port
    private final int RB_12 = (int)12;                                                              // für Port
    private final int RB_13 = (int)13;                                                              // für Port
    private final int RB_14 = (int)14;                                                              // für Port
    private final int RB_15 = (int)15;                                                              // für Port

    // Zusatzkommandos
    private final int AKTIV = (int)1;                                                               // für Wert
    private final int UNBENUTZT = (int)0;                                                           // für Wert

    private boolean deviceAttached = false;
    private int Portanfrage = -1;
    private USBAccessoryManager accessoryManager = null;

    // Variablen für automatische Abfrage
    private Handler AutomatikHandler = null;
    private Runnable mMyRunnable = null;

    // Variablen für Steuerelemente im Layout
    private ToggleButton togglebutton_extern_adc_freigeben = null;
    private EditText editText_extern_adc_eingabe = null;
    private Button
            button_extern_adc_speichern = null, button_extern_adc_automatisch = null, button_extern_adc_manuell = null;

    private Spinner
            spinner_extern_adc_sensorauswahl = null, spinner_extern_adc_portauswahl = null, spinner_extern_adc_typ = null;

    private TextView
            text_extern_adc_sekunden = null, text_extern_adc_sensor = null, text_extern_adc_anschluss = null,
            text_extern_adc_wert = null, text_extern_adc_wert_fertig = null, text_extern_adc_typ = null;


    /* 1. TODO:
    Wenn ein neuer Sensor angeschlossen und die App angepasst werden soll (neuer Sensortyp aber keine neue Sensorgruppe):
        1. In der Datei arrays.xml die Sensorbezeichnung in das richtige Array schreiben
        2. In der Funktion "WertEintragen()" an der Stelle "T-O-D-O" dem Beispiel folgen
    */
    /* 2. TODO:
    Wenn ein neuer Sensor angeschlossen und die App angepasst werden soll (neuer Sensortyp und neue Sensorgruppe):
        1. Neuen Gruppennamen in das Array "sensoren_adc" eintragen und den vergebenen Namen merken
        2. In der Datei arrays.xml ein neues Sensorarray anlegen (siehe Beispiel TypenTemperatur zum Beispiel) und den Namen merken
        3. In der Funktion "SpinnerInit()" an der Stelle "T-O-D-O" dem Beispiel folgen
        4. In der Datei arrays.xml die Sensorbezeichnung in das neu angelegte Array schreiben
        5. In der Funktion "WertEintragen()" an der Stelle "T-O-D-O" dem Beispiel folgen
    */

    private void WertEintragen(int Wert)
    {
        int Wert_fertig = 0;                                                                        // Variable für fertig konvertieren Sensorwert
        String Einheit = "";                                                                        // Variable für die Einheit

        // Einheit, je nach Sensortyp, setzen
        if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Temperatur")){Einheit = " °C";}
        if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Potentiometer")){Einheit = " %";}
        if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Licht")){Einheit = " %";}

        text_extern_adc_wert.setText(String.valueOf(Wert));                                         // Rohwert eintragen

        //Wert anpassen
        Wert_fertig = Wert;                                                                         // Rohwert kopieren
        if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("POT 10K Trim CERM"))    // Wenn es das integrierte Potentiometer ist
        {
            Wert_fertig = (Wert_fertig*100)/1023;                                                   // Wert anpassen
            text_extern_adc_wert_fertig.setText(String.valueOf(Wert_fertig) + Einheit);             // Wert im Layout ausgeben
        }
        if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("TI LM19"))              // Wenn es der LM19 Temperatursensor ist
        {
            double Volt = (((double)Wert_fertig)/1023)*3.3;                                         // Wert anpassen
            double Wurzel = Math.sqrt(2196200+((1.8639-Volt)/0.00000388));                          //       ||
            double Temperatur = (-1481.96)+Wurzel;                                                  //       ||

            double Sensorwert = DoubleRunden(Temperatur,1);                                         // Wert runden

            text_extern_adc_wert_fertig.setText(String.valueOf(Sensorwert) + Einheit);              // Wert im Layout ausgeben
        }
        if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("BP 103 (ohne Licht)")   // Wenn es der BP103 Fototransistor ist
                ||String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("BP 103 (mit Licht)"))
        {
            Wert_fertig = (Wert_fertig*100)/1023;                                                   // Wert anpassen
            text_extern_adc_wert_fertig.setText(String.valueOf(Wert_fertig) + Einheit);             // Wert im Layout ausgeben
        }

        /*---------- TODO:

        // Bei Anlegen einer ganz neuen Sensorgruppe zusätzlich diesen Teil benutzen:
        // Den Namen eintragen der unter 2.1 in das Sensorarray geschrieben wurde (Sensorgruppenname)
        // Passende Einheit eintragen
        if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("GRUPPENNAME eintragen")){Einheit = " EINHEIT eintragen";}


        // Bei Anlegen eines neuen Sensortyps diesem Beispiel folgen:
        // Unter TYPNAME den in 1.1 in der arrays.xml Datei vergebenen Typnamen eintragen
        if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("TYPNAME"))
        {
            // Die passende Konvertierungs- und Linearisierungsmethode einfügen (bei ........)
            Wert_fertig = .............

            // Wert im Layout ausgeben
            text_extern_adc_wert_fertig.setText(String.valueOf(Wert_fertig) + Einheit);
        }
         */
    }

    private void SpinnerInit()
    {
        /*---------- TODO:
        // Anlegen eines neuen Auswahlmenüs
        final String[] VARIABLENNAMEN_StringArray eintragen = getResources().getStringArray(R.array.ARRAYNAMEN eintragen);
        final ArrayAdapter<String> VARIABLENNAMEN_ArrayAdapter eintragen = new ArrayAdapter<String>(this, R.layout.my_spinner, VARIABLENNAMEN_StringArray eintragen);
        */


        // Anlegen der einzelnen Array-Untermenüs
        final String[] Pot_Typen = getResources().getStringArray(R.array.typen_potentiometer);      // StringArray anlegen
        final ArrayAdapter<String> mAdapter_Pot = new ArrayAdapter<String>(this, R.layout.my_spinner, Pot_Typen);        // In Spinnerlayout einbetten

        final String[] Temp_Typen = getResources().getStringArray(R.array.typen_temperatur);
        final ArrayAdapter<String> mAdapter_Temp = new ArrayAdapter<String>(this, R.layout.my_spinner, Temp_Typen);

        final String[] Licht_Typen = getResources().getStringArray(R.array.typen_licht);
        final ArrayAdapter<String> mAdapter_Licht = new ArrayAdapter<String>(this, R.layout.my_spinner, Licht_Typen);

        final String[] Sonstiges_Typen = getResources().getStringArray(R.array.typen_sonstiges);
        final ArrayAdapter<String> mAdapter_Sonstiges = new ArrayAdapter<String>(this, R.layout.my_spinner, Sonstiges_Typen);

        final String[] Default_Typen = getResources().getStringArray(R.array.typen_default);
        final ArrayAdapter<String> mAdapter_Default = new ArrayAdapter<String>(this, R.layout.my_spinner, Default_Typen);

        final String[] Sensoren_Auswahl = getResources().getStringArray(R.array.sensoren_adc);
        final ArrayAdapter<String> mAdapter_Sensoren = new ArrayAdapter<String>(this, R.layout.my_spinner, Sensoren_Auswahl);

        final String[] Anschluss_Auswahl = getResources().getStringArray(R.array.anschluesse_adc);
        final ArrayAdapter<String> mAdapter_Anschluss = new ArrayAdapter<String>(this, R.layout.my_spinner, Anschluss_Auswahl);

        spinner_extern_adc_typ.setAdapter(mAdapter_Default);        // Standardtexte für Start des Layouts eintragen
        spinner_extern_adc_sensorauswahl.setAdapter(mAdapter_Sensoren);        // Standardtexte für Start des Layouts eintragen
        spinner_extern_adc_portauswahl.setAdapter(mAdapter_Anschluss);        // Standardtexte für Start des Layouts eintragen

        spinner_extern_adc_sensorauswahl.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()     // Wenn in der Sensorgruppe ein Sensor ausgewählt wird
        {
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                /*---------- TODO:
                // Wenn das Menü angeklickt wird, muss auch ein neues Array geladen werden
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("SENSORGRUPPENNAMEN eintragen"))
                {
                    spinner_extern_adc_typ.setAdapter(VARIABLENNAMEN_ArrayAdapter von oben eintragen);
                    spinner_extern_adc_portauswahl.setSelection(0);
                }
                */

                // Jeweils passende Texte für die Typen einsetzen, wenn die richtige Sensorgruppe ausgewählt wird
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Sonstiges"))
                {
                    spinner_extern_adc_typ.setAdapter(mAdapter_Sonstiges);
                    spinner_extern_adc_portauswahl.setSelection(0);
                }
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Potentiometer"))
                {
                    spinner_extern_adc_portauswahl.setSelection(7);         // Schon passende Autovervollständigung beim Port eingeben
                    spinner_extern_adc_typ.setAdapter(mAdapter_Pot);        // Typbezeichnungen laden
                }
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Temperatur"))
                {
                    spinner_extern_adc_typ.setAdapter(mAdapter_Temp);
                    spinner_extern_adc_portauswahl.setSelection(8);
                }
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("Licht"))
                {
                    spinner_extern_adc_typ.setAdapter(mAdapter_Licht);
                    spinner_extern_adc_portauswahl.setSelection(9);
                }
            }

            public void onNothingSelected(AdapterView<?> parentView){}
        });

        spinner_extern_adc_portauswahl.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()
        {
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                // Da an AN9 das Potentiometer fes verdrahtet ist, kann bei Auswahl des Ports nur das Potentiometer abgefragt werden -> Autovervollständigung setzt das passend
                if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN9 (an Potentiometer)"))
                {
                    spinner_extern_adc_sensorauswahl.setSelection(1);
                    spinner_extern_adc_typ.setAdapter(mAdapter_Pot);
                }
            }

            public void onNothingSelected(AdapterView<?> parentView){}
        });

        spinner_extern_adc_typ.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()
        {
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                // Wenn Potentiometer in der Sensorgruppe ausgewählt wird auch den Port direkt richtig setzen
                // Es wird eigl. nur das eingebaute Potentiometer abgefragt
                if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("Potentiometer"))
                {
                    spinner_extern_adc_portauswahl.setSelection(7);
                }
            }

            public void onNothingSelected(AdapterView<?> parentView){}
        });
    }

    // *************************************************************************************
    // Für Anpassungen muss unterhalb dieses Schriftzugs in der Regel nichts geändert werden
    // *************************************************************************************

    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_extern_adc);                                               // Layout laden

        // für USB:
        accessoryManager = new USBAccessoryManager(handler, USBAccessoryWhat);                      // USB Accessory Manager starten

        LayoutInit();                                                                               // Steuerlementvariablen mit IDs konfigurieren
        ButtonInit();                                                                               // Buttonfunktionalität konfigurieren
        SpinnerInit();                                                                              // Dropdown-Menüs konfigurieren
        Sichtbar(false);                                                                            // Unteren Teil des Layouts unsichtbar schalten
    }

    private void LayoutInit()                                                                       // Die einzelnen Steuerelemente als Variablen anlegen, damit sie bei Bedarf ausgelesen oder verändert werden können
    {
        editText_extern_adc_eingabe = (EditText)findViewById(R.id.sensor_extern_adc_eingabe);
        text_extern_adc_sekunden = (TextView)findViewById(R.id.sensor_extern_adc_sekunde);
        text_extern_adc_sensor = (TextView)findViewById(R.id.sensor_extern_adc_sensorauswahl);
        text_extern_adc_typ = (TextView)findViewById(R.id.sensor_extern_adc_typ);
        text_extern_adc_anschluss = (TextView)findViewById(R.id.sensor_extern_adc_portauswahl);
        text_extern_adc_wert = (TextView)findViewById(R.id.sensor_extern_adc_wert);
        text_extern_adc_wert_fertig = (TextView)findViewById(R.id.sensor_extern_adc_wert_fertig);
        button_extern_adc_automatisch = (Button)findViewById(R.id.sensor_extern_adc_automatisch);
        button_extern_adc_manuell = (Button)findViewById(R.id.sensor_extern_adc_manuell);
        button_extern_adc_speichern = (Button)findViewById(R.id.sensor_extern_adc_speichern);
        togglebutton_extern_adc_freigeben = (ToggleButton)findViewById(R.id.sensor_extern_togglebutton);
        spinner_extern_adc_sensorauswahl = (Spinner)findViewById(R.id.spinner_adc_sensoren);
        spinner_extern_adc_portauswahl = (Spinner)findViewById(R.id.spinner_adc_portauswahl);
        spinner_extern_adc_typ = (Spinner)findViewById(R.id.spinner_adc_typ);
    }

    private void ButtonInit()                                                                       // Buttons mit Funktionen hinterlegen
    {
        togglebutton_extern_adc_freigeben.setOnClickListener(new View.OnClickListener()             // Wenn "Sensor ändern" gedrückt wird
        {
            public void onClick(View v)
            {
                button_extern_adc_speichern.setEnabled(true);                                       // Einige Schaltflächen oben wieder aktivieren
                spinner_extern_adc_sensorauswahl.setEnabled(true);
                spinner_extern_adc_typ.setEnabled(true);
                spinner_extern_adc_portauswahl.setEnabled(true);
                text_extern_adc_sensor.setEnabled(true);
                text_extern_adc_typ.setEnabled(true);
                text_extern_adc_anschluss.setEnabled(true);

				Portanfrage = -1;                                                                   // Portanfrage löschen

                Sichtbar(false);                                                                    // Unteren Abfrageteil unsichtbar schalten -> Alles wieder auf Anfang
            }
        });


        button_extern_adc_automatisch.setOnClickListener(new View.OnClickListener()                 // Wenn eine automatische Abfrage erfolgen soll
        {
            public void onClick(View v)
            {
                String str_Intervall = String.valueOf(editText_extern_adc_eingabe.getText());       // Text auslesen wie oft abgefragt werden soll
                Integer Intervall = Integer.valueOf(str_Intervall);                                 // Intervall aus Text auslesen
                if((Intervall > 60000) || (Intervall < 50))                                         // Passt der in das Min/Max Intervall?
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_adc_intervall_toast, Toast.LENGTH_SHORT).show();    // Wenn nicht -> Meldung anzeigen
                }
                else                                                                                // Wenn ja -> Wert abfragen
                {
                    button_extern_adc_automatisch.setEnabled(false);                                // Abfragebuttons deaktivieren (es läuft ja gerade eine Abfrage)
                    editText_extern_adc_eingabe.setEnabled(false);                                  // Eingaben unterbinden....
                    text_extern_adc_sekunden.setEnabled(false);
                    togglebutton_extern_adc_freigeben.setEnabled(false);
                    togglebutton_extern_adc_freigeben.setChecked(false);

                    button_extern_adc_manuell.setText(R.string.sensor_extern_adc_stop);             // Start zu Stop Knopf machen

                    AbfrageAutomatisch();                                                           // Automatische Abfrage durchführen
                }
            }
        });

        button_extern_adc_manuell.setOnClickListener(new View.OnClickListener() {                   // Manuelle Abfrage starten
            public void onClick(View v) {
                if (button_extern_adc_manuell.getText() == getString(R.string.sensor_extern_adc_stop))    // Wenn der Knopf grade als Stop Kopf für die Automatische Abfrage genutzt wird:
                {
                    button_extern_adc_automatisch.setEnabled(true);                                 // Einige Schaltflächen wieder aktivieren
                    editText_extern_adc_eingabe.setEnabled(true);
                    text_extern_adc_sekunden.setEnabled(true);
                    button_extern_adc_manuell.setText(R.string.sensor_extern_adc_manuell_text);     // Stop Knopf wieder zum Start Knopf machen
                    togglebutton_extern_adc_freigeben.setEnabled(true);
                    togglebutton_extern_adc_freigeben.setChecked(true);

                    AutomatikHandler.removeCallbacks(mMyRunnable);                                  // Automatische Abfrage beenden
                }
                else                                                                                // Wenn der Knopf nicht als Stop Knopf genutzt wird
                {
                    ADRead();                                                                       // Manuelle Abfrage durchführen
                }
            }
        });

        button_extern_adc_speichern.setOnClickListener(new View.OnClickListener()                   // Wenn auf Initialisieren gedrückt wird
        {
            public void onClick(View v)
            {
                if(String.valueOf(spinner_extern_adc_sensorauswahl.getSelectedItem()).equals("-Bitte auswählen-"))    // Kein Sensor ausgewählt
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_adc_sensorauswahl_toast, Toast.LENGTH_SHORT).show();    // Meldung anzeigen
                }
                else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("-Bitte auswählen-"))    // Kein Port ausgewählt
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_adc_portauswahl_toast, Toast.LENGTH_SHORT).show();    // Meldung anzeigen
                }
                else                                                                                // Initialisierung durchführen
                {
                    button_extern_adc_speichern.setEnabled(false);                                  // Oberen Schaltflächen deaktivieren
                    spinner_extern_adc_sensorauswahl.setEnabled(false);
                    spinner_extern_adc_typ.setEnabled(false);
                    spinner_extern_adc_portauswahl.setEnabled(false);
                    text_extern_adc_sensor.setEnabled(false);
                    text_extern_adc_typ.setEnabled(false);
                    text_extern_adc_anschluss.setEnabled(false);

                    Sichtbar(true);                                                                 // Untere Schaltflächen (Abfrageteil) aktivieren und sichtbar machen
                    ADConfig();                                                                     // Konfiguration des A/D-Wandlers durchführen
                }
            }
        });
    }

    private void AbfrageAutomatisch()                                                               // Automatische Abfrage durchführen
    {
        AutomatikHandler = new Handler();                                                           // Neuen Automatikhandler erstellen

        String str_Intervall = String.valueOf(editText_extern_adc_eingabe.getText());
        final Integer Intervall = Integer.valueOf(str_Intervall);                                   // Intervall auslesen

        mMyRunnable = new Runnable()
        {
            public void run()
            {
                ADRead();                                                                           // Alle x Millisekunden Abfrage durchführen
                AutomatikHandler.postDelayed(this, Intervall);                                      // Dann den Handler nach der Intervall-Zeit neustarten
            }
        };

        ADRead();                                                                                   // Sensor abfragen, ansonsten wäre die erste Abfrage erst nach X Millisekunden
        AutomatikHandler.postDelayed(mMyRunnable, Intervall);                                       // Automatikbetrieb starten
    }

    private void ADConfig()                                                                         // A/D-Wandler konfigurieren
    {
        // Schauen welcher Port konfiguriert werden soll -> dementsprechend Kommando senden
        if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN0 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_0, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN1 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_1, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN2 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_2, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN3 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_3, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN4 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_4, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN8 (an J5)")){KommandoSenden(AD_WANDLER_CONFIG, AN_8, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN9 (an Potentiometer)")){KommandoSenden(AD_WANDLER_CONFIG, AN_9, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB12 (an J7)")){KommandoSenden(AD_WANDLER_CONFIG, RB_12, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB13 (an J7)")){KommandoSenden(AD_WANDLER_CONFIG, RB_13, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB14 (an J7)")){KommandoSenden(AD_WANDLER_CONFIG, RB_14, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB15 (an J7)")){KommandoSenden(AD_WANDLER_CONFIG, RB_15, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
    }

    private void ADRead()                                                                           // A/D-Wandler abfragen
    {
        int Licht = UNBENUTZT;                                                                      // Ob Licht für den Fototransistor eingeschaltet werden soll
        if(String.valueOf(spinner_extern_adc_typ.getSelectedItem()).equals("BP 103 (mit Licht)")){Licht = AKTIV;}       // Wenn ja, dann Licht aktiv setzen

        // Schauen welcher Port genutzt wird und dementsprechendes Kommando senden
        if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN0 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_0, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_0;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN1 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_1, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_1;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN2 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_2, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_2;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN3 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_3, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_3;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN4 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_4, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_4;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN8 (an J5)")){KommandoSenden(AD_WANDLER_READ, AN_8, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_8;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("AN9 (an Potentiometer)")){KommandoSenden(AD_WANDLER_READ, AN_9, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = AN_9;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB12 (an J7)")){KommandoSenden(AD_WANDLER_READ, RB_12, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = RB_12;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB13 (an J7)")){KommandoSenden(AD_WANDLER_READ, RB_13, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = RB_13;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB14 (an J7)")){KommandoSenden(AD_WANDLER_READ, RB_14, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = RB_14;}
        else if(String.valueOf(spinner_extern_adc_portauswahl.getSelectedItem()).equals("RB15 (an J7)")){KommandoSenden(AD_WANDLER_READ, RB_15, Licht, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = RB_15;}
    }

    private int WertZusammensetzen(byte commandPacket[])                                            // Empfangenen Sensorwert aus 2 Byte in Int zusammenfügen
    {
        int Sensorwert = 0;

        Sensorwert = ((int)commandPacket[2] & 0xFF)*256 + ((int)commandPacket[3] & 0xFF);           // Sensorwert zusammenfügen -> Warum genau so: Siehe Ausarbeitung

        return Sensorwert;                                                                          // fertigen Sensorwert zurückgeben
    }

    private void KommandoEmpfangen(byte commandPacket[])                                            // Empfangenes Kommando untersuchen
    {
        if(commandPacket[0] == (byte)AD_WANDLER_READ)                                               // War es eine A/D-Wandler Abfrage?
        {
            if(commandPacket[1] == (byte)Portanfrage)                                               // War es der gewollte Port?
            {
                WertEintragen(WertZusammensetzen(commandPacket));                                   // Wenn ja: Dann Wert zusammensetzen und ausgeben
            }
            else
            {
                Toast.makeText(getApplicationContext(), R.string.sensor_extern_adc_error_port_toast, Toast.LENGTH_LONG).show();     // Wenn nicht ist ein Fehler unterlaufen: EIne Meldung wird angezeigt
            }
        }
        else
        {
            Toast.makeText(getApplicationContext(), R.string.sensor_extern_adc_error_ad_toast, Toast.LENGTH_LONG).show();     // Wenn nicht ist ein Fehler unterlaufen: EIne Meldung wird angezeigt
        }
    }

    private void KommandoSenden(int Typ, int Port, int Wert1, int Wert2, int Wert3, int Wert4, int Wert5, int Wert6)    // Senden eines Kommandos an den Mikrocontroller
    {
        byte[] commandPacket = new byte[8];
        commandPacket[0] = (byte) Typ;                                                              // Kommandotyp
        commandPacket[1] = (byte) Port;                                                             // Gewünschter Kanal / Port
        commandPacket[2] = (byte) Wert1;                                                            // z.B. ob das Licht eingeschaltet werden soll
        commandPacket[3] = (byte) Wert2;                                                            // ...
        commandPacket[4] = (byte) Wert3;                                                            // Unbenutzt
        commandPacket[5] = (byte) Wert4;                                                            // Unbenutzt
        commandPacket[6] = (byte) Wert5;                                                            // Unbenutzt
        commandPacket[7] = (byte) Wert6;                                                            // Unbenutzt

        accessoryManager.write(commandPacket);                                                      // Datenpaket senden
    }

    private double DoubleRunden(double wert, int stellen)                                           // Wert runden auf "stellen"-Stellen
    {
        double gerundet = Math.round(wert * Math.pow(10d, stellen));
        return gerundet / Math.pow(10d, stellen);
    }

    private void Sichtbar(boolean Zustand)                                                          // Unteren Abfrageteil (also die Schaltflächen) sichtbar oder unsichtbar schalten
    {
        int Sichtbarkeit = 0;
        if(Zustand == true){Sichtbarkeit = View.VISIBLE;}
        else{Sichtbarkeit = View.INVISIBLE;}

        ProgressBar mTrennstrich = (ProgressBar)findViewById(R.id.Trennstrich);
        mTrennstrich.setVisibility(Sichtbarkeit);
        TextView mAktualisierung = (TextView)findViewById(R.id.sensor_extern_adc_aktualisierung);
        mAktualisierung.setVisibility(Sichtbarkeit);
        button_extern_adc_automatisch.setVisibility(Sichtbarkeit);
        editText_extern_adc_eingabe.setVisibility(Sichtbarkeit);
        text_extern_adc_sekunden.setVisibility(Sichtbarkeit);
        button_extern_adc_manuell.setVisibility(Sichtbarkeit);
        TextView mSensorwert = (TextView)findViewById(R.id.sensor_extern_adc_sensorwert);
        mSensorwert.setVisibility(Sichtbarkeit);
        TextView mSensorwert_fertig = (TextView)findViewById(R.id.sensor_extern_adc_sensorwert_fertig);
        mSensorwert_fertig.setVisibility(Sichtbarkeit);
        text_extern_adc_wert.setVisibility(Sichtbarkeit);
        text_extern_adc_wert.setText(R.string.sensor_extern_adc_wert_text);
        text_extern_adc_wert_fertig.setVisibility(Sichtbarkeit);
        text_extern_adc_wert_fertig.setText(R.string.sensor_extern_adc_wert_fertig_text);
        togglebutton_extern_adc_freigeben.setVisibility(Sichtbarkeit);
        togglebutton_extern_adc_freigeben.setChecked(true);
    }

    public void onPause()                                                                           // Wenn die App pausiert /minimiert wird
    {
        KommandoSenden(APP_DISCONNECT,UNBENUTZT,UNBENUTZT,UNBENUTZT,UNBENUTZT,UNBENUTZT, UNBENUTZT, UNBENUTZT);     // Dem Mikrocontroller mitteilen, dass er in "Standbye" gehen kann

        try{while(accessoryManager.isClosed() == false){Thread.sleep(500);}}                        // Warten bis der Accessory Manager geschlossen wird
        catch(InterruptedException e){e.printStackTrace();}                                         // Wenn das nicht geklappt hat -> Fehler ausgeben

        super.onPause();                                                                            // Programm pausieren
        accessoryManager.disable(this);                                                             // AccessoryManager ausschalten
        disconnectAccessory();                                                                      // Verbindung trennen
    }

    public void onResume()                                                                          // Wenn Programm wieder geöffnet wird
    {
        super.onResume();                                                                           // Program starten
        accessoryManager.enable(this, getIntent());                                                 // Accessory Manager wieder starten
    }
    
    private void TitelVerbunden(boolean verbunden)                                                  // Titel ändern wenn Board verbunden oder getrennt wird
    {
        TextView text_board_ueberschrift;
        text_board_ueberschrift=(TextView)findViewById(R.id.extern_adc_titel);
        if(verbunden == true)                                                                       // Wenn verbunden -> dann auch hinschreiben und grün unterlegen
        {
            text_board_ueberschrift.setText(R.string.extern_activity_verbunden);
            text_board_ueberschrift.setBackgroundColor(Color.GREEN);
            button_extern_adc_speichern.setEnabled(true);                                           // Initialisierenknopf kann gedrückt werden
        }
        else
        {
            text_board_ueberschrift.setText(R.string.extern_activity_nichtverbunden);               // Wenn nicht -> hinschreiben und rot machen
            text_board_ueberschrift.setBackgroundColor(Color.RED);

            if (button_extern_adc_manuell.getText() == getString(R.string.sensor_extern_adc_stop))  // Wenn der Stecker gezogen wird obwohl eine Abfrage läuft: Automatische Abfrage stoppen
            {
                button_extern_adc_automatisch.setEnabled(true);                                     // Felder unsichtbar schalten -> alles wieder auf Anfang
                editText_extern_adc_eingabe.setEnabled(true);
                text_extern_adc_sekunden.setEnabled(true);
                button_extern_adc_manuell.setText(R.string.sensor_extern_adc_manuell_text);
                togglebutton_extern_adc_freigeben.setEnabled(true);
                togglebutton_extern_adc_freigeben.setChecked(true);

                AutomatikHandler.removeCallbacks(mMyRunnable);
            }

            button_extern_adc_speichern.setEnabled(true);                                           // Sensorwerte unsichtbar schalten
            spinner_extern_adc_sensorauswahl.setEnabled(true);
            spinner_extern_adc_typ.setEnabled(true);
            spinner_extern_adc_portauswahl.setEnabled(true);
            text_extern_adc_sensor.setEnabled(true);
            text_extern_adc_typ.setEnabled(true);
            text_extern_adc_anschluss.setEnabled(true);

            Sichtbar(false);                                                                        // Unteren Teil wieder unsichtbar schalten

            button_extern_adc_speichern.setEnabled(false);                                          // Intitialisieren-Knopf kann nicht gedrückt werden bis wieder verbunden wird
        }
    }
    
    private void disconnectAccessory()                                                              // Accessory disconnecten
    {
        if(deviceAttached == false){return;}
        TitelVerbunden(false);
    }
    
    private Handler handler = new Handler()                                                         // USB-Handler (kümmert sich um die Kommunikation mit dem Board)
    {
        public void handleMessage(Message msg)                                                      // Wenn eine neue Nachricht reinkommt
        {
            byte[] commandPacket = new byte[8];                                                     // Datenpaket anlegen

            switch(msg.what)                                                                        // Was war es für ein Kommando
            {
                case USBAccessoryWhat:                                                              // Welcher Inhalt
                    switch(((USBAccessoryManagerMessage)msg.obj).type)
                    {
                        case READ:                                                                  // Es war ein Read-Kommando vom Board
                            if(accessoryManager.isConnected() == false){return;}                    // Wenn nicht verbunden ist -> egal

                            while(true)
                            {
                                if(accessoryManager.available() < 8){break;}                        // Alle Kommandos sind 8 Byte lang -> Was kürzeres war ein unvollständiges Kommando

                                accessoryManager.read(commandPacket);                               // Kommando vom USB Handler abfragen

                                KommandoEmpfangen(commandPacket);                                   // Kommando analysieren
                            }break;

                        case CONNECTED:	break;                                                      // Wenn gesagt wird, dass verbunden wurde -> weitermachen

                        case READY:                                                                 // Wenn das Board sagt, dass es bereit zum verbinden ist -> Verbinden Kommando senden
                            deviceAttached = true;
                            TitelVerbunden(true);                                                   // Titel ändern
                            KommandoSenden(APP_CONNECT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);   // Kommando senden
                            break;

                        case DISCONNECTED:                                                          // Wenn es ein Disconnect vom Board war -> Verbindung trennen
                            disconnectAccessory();
                            break;
                    }break;

                default: break;
            }	//switch
        } //handleMessage
    }; //handler

    // ------------ Menü ----------------- Kommentare siehe StartActivity

    public boolean onCreateOptionsMenu(Menu menu)
    {
        getMenuInflater().inflate(R.menu.menu_klein, menu);
        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item)
    {
        switch (item.getItemId())
        {
            case R.id.action_info:
                Info();
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void Info()
    {
        AlertDialog alertDialog = new AlertDialog.Builder(this).create();
        alertDialog.setTitle("INFO");
        alertDialog.setMessage(getString(R.string.menue_info_text));
        alertDialog.setButton("OK", new DialogInterface.OnClickListener()
        {public void onClick(DialogInterface dialog, int which) {}});
        alertDialog.show();
    }
}
