package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

public class ExternActivity_I2C extends ActionBarActivity
{
    private final int USBAccessoryWhat = 0;                                                         // für msg

    private final int I2C_CONFIG         = (int)0xBC;                                               // für Typ
    private final int I2C_READ           = (int)0xBD;                                               // für Typ
    private final int APP_CONNECT		 = (int)0xFE;                                               // für Typ
    private final int APP_DISCONNECT	 = (int)0xFF;                                               // für Typ

    private final int SDA_1 = (int)1;                                                               // für Port
    private final int SDA_2 = (int)2;                                                               // für Port

    private final int AKTIV = (int)1;                                                               // für Wert -> bei Config
    private final int UNBENUTZT = (int)0;                                                           // für Wert

    private boolean deviceAttached = false;
    private USBAccessoryManager accessoryManager = null;

    // Variablen für Steuerelemente im Layout
    private Button
            button_extern_i2c_speichern = null, button_extern_i2c_automatisch = null, button_extern_i2c_manuell = null;

    private Spinner
            spinner_extern_i2c_sensorauswahl = null, spinner_extern_i2c_portauswahl = null, spinner_extern_i2c_typ = null;

    private EditText
            editText_extern_i2c_eingabe = null, editText_extern_i2c_adresse_eingabe = null;

    // Variablen für automatische Abfrage
    private Handler
            AutomatikHandler = null;

    private Runnable
            mMyRunnable = null;

    private TextView
            text_extern_i2c_sekunden = null, text_extern_i2c_sensor = null, text_extern_i2c_anschluss = null,
            text_extern_i2c_adresse = null, text_extern_i2c_wert = null, text_extern_i2c_typ = null;

    private int
            Portanfrage = -1;

    private ToggleButton
            togglebutton_extern_i2c_freigeben = null;

    /* 1. TODO:
    Wenn ein neuer Sensor angeschlossen und die App angepasst werden soll (neuer Sensortyp aber keine neue Sensorgruppe):
        1. In der Datei arrays.xml die Sensorbezeichnung in das richtige Array schreiben
        2. In der Funktion "WertEintragen()" an der Stelle "T-O-D-O" dem Beispiel folgen
    */
    /* 2. TODO:
    Wenn ein neuer Sensor angeschlossen und die App angepasst werden soll (neuer Sensortyp und neue Sensorgruppe):
        1. Neuen Gruppennamen in das Array "sensoren_i2c" eintragen und den vergebenen Namen merken
        2. In der Datei arrays.xml ein neues Sensorarray anlegen (siehe Beispiel TypenTemperaturI2C zum Beispiel) und den Namen merken
        3. In der Funktion "SpinnerInit()" an der Stelle "T-O-D-O" dem Beispiel folgen
        4. In der Datei arrays.xml die Sensorbezeichnung in das neu angelegte Array schreiben
        5. In der Funktion "WertEintragen()" an der Stelle "T-O-D-O" dem Beispiel folgen
    */

    private void WertEintragen(int Wert)
    {
        String Einheit = "";                                                                        // Variable für die Einheit

        double Wert_fertig = 0;                                                                     // Variable für fertig konvertieren Sensorwert

        // Einheit, je nach Sensortyp, setzen
        if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("Temperatur")){Einheit = " °C";}

        //Wert anpassen
        if(String.valueOf(spinner_extern_i2c_typ.getSelectedItem()).equals("TI LM75A"))             // Wenn es der angeschlossene digitale Tempsensor ist -> dieser braucht noch eine Korrektur des Wertes
        {
            Wert_fertig = DoubleRunden((((double)Wert) / 256),2);                                   // da die letzten Bits unbenutzt sind -> genaueres siehe Ausarbeitung
        }
        text_extern_i2c_wert.setText(String.valueOf(Wert_fertig) + Einheit);                        // Wert im Layout ausgeben

        /*---------- TODO:

        // Bei Anlegen einer ganz neuen Sensorgruppe zusätzlich diesen Teil benutzen:
        // Den Namen eintragen der unter 2.1 in das Sensorarray geschrieben wurde (Sensorgruppenname)
        // Passende Einheit eintragen
        if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("GRUPPENNAME eintragen")){Einheit = " EINHEIT eintragen";}


        // Bei Anlegen eines neuen Sensortyps diesem Beispiel folgen:
        // Unter TYPNAME den in 1.1 in der arrays.xml Datei vergebenen Typnamen eintragen
        if(String.valueOf(spinner_extern_i2c_typ.getSelectedItem()).equals("TYPNAME"))
        {
            // Die passende Konvertierungsmethode einfügen (bei ........)
            Wert_fertig = .............

            // Wert im Layout ausgeben
            text_extern_i2c_wert_fertig.setText(String.valueOf(Wert_fertig) + Einheit);
        }
         */
    }

    private void SpinnerInit()
    {
        /*---------- TODO:
        // Anlegen eines neuen Auswahlmenüs
        final String[] VARIABLENNAMEN_StringArray eintragen = getResources().getStringArray(R.array.ARRAYNAMEN eintragen);
        final ArrayAdapter<String> VARIABLENNAMEN_ArrayAdapter eintragen = new ArrayAdapter<String>(this, R.layout.my_spinner, VARIABLENNAMEN_StringArray eintragen);
        */

        final String[] Temp_Typen_i2c = getResources().getStringArray(R.array.typen_temperatur_i2c);      // StringArray anlegen
        final ArrayAdapter<String> mAdapter_Temp_i2c = new ArrayAdapter<String>(this, R.layout.my_spinner, Temp_Typen_i2c);        // In Spinnerlayout einbetten

        final String[] Sonstiges_Typen = getResources().getStringArray(R.array.typen_sonstiges);
        final ArrayAdapter<String> mAdapter_Sonstiges = new ArrayAdapter<String>(this, R.layout.my_spinner, Sonstiges_Typen);

        final String[] Default_Typen = getResources().getStringArray(R.array.typen_default);
        final ArrayAdapter<String> mAdapter_Default = new ArrayAdapter<String>(this, R.layout.my_spinner, Default_Typen);

        final String[] Sensoren_Auswahl = getResources().getStringArray(R.array.sensoren_i2c);
        final ArrayAdapter<String> mAdapter_Sensoren = new ArrayAdapter<String>(this, R.layout.my_spinner, Sensoren_Auswahl);

        final String[] Anschluss_Auswahl = getResources().getStringArray(R.array.anschluesse_i2c);
        final ArrayAdapter<String> mAdapter_Anschluss = new ArrayAdapter<String>(this, R.layout.my_spinner, Anschluss_Auswahl);

        spinner_extern_i2c_typ.setAdapter(mAdapter_Default);                    // Standardtexte für Start des Layouts eintragen
        spinner_extern_i2c_sensorauswahl.setAdapter(mAdapter_Sensoren);         // Standardtexte für Start des Layouts eintragen
        spinner_extern_i2c_portauswahl.setAdapter(mAdapter_Anschluss);          // Standardtexte für Start des Layouts eintragen

        spinner_extern_i2c_sensorauswahl.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()  // Wenn in der Sensorgruppe ein Sensor ausgewählt wird
        {
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                /*---------- TODO:
                // Wenn das Menü angeklickt wird, muss auch ein neues Array geladen werden
                if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("SENSORGRUPPENNAMEN eintragen"))
                {
                    spinner_extern_i2c_typ.setAdapter(VARIABLENNAMEN_ArrayAdapter von oben eintragen);
                    spinner_extern_i2c_portauswahl.setSelection(0);
                    editText_extern_i2c_adresse_eingabe.setText("");
                }
                */

                // Jeweils passende Texte für die Typen einsetzen, wenn die richtige Sensorgruppe ausgewählt wird
                if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("Temperatur"))
                {
                    spinner_extern_i2c_typ.setAdapter(mAdapter_Temp_i2c);                           // Typbezeichnungen laden
                    spinner_extern_i2c_portauswahl.setSelection(1);                                 // Schon passende Autovervollständigung beim Port eing
                }
                if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("Sonstiges"))
                {
                    spinner_extern_i2c_typ.setAdapter(mAdapter_Sonstiges);
                    spinner_extern_i2c_portauswahl.setSelection(0);
                    editText_extern_i2c_adresse_eingabe.setText("");                                // Adressfeld leeren
                }
            }

            public void onNothingSelected(AdapterView<?> parentView){}
        });

        spinner_extern_i2c_typ.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()
        {
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                // Autovervollständigung von Adressen
                if(String.valueOf(spinner_extern_i2c_typ.getSelectedItem()).equals("TI LM75A"))
                {
                    editText_extern_i2c_adresse_eingabe.setText("144");                             // Ist mit Adresse 144 ansprechbar
                }
            }

            public void onNothingSelected(AdapterView<?> parentView){}
        });
    }

    // *************************************************************************************
    // Für Anpassungen muss unterhalb dieses Schriftzugs in der Regel nichts geändert werden
    // *************************************************************************************

    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_extern_i2c);                                               // Layout laden

        // für USB:
        accessoryManager = new USBAccessoryManager(handler, USBAccessoryWhat);                      // USB Accessory Manager starten

        LayoutInit();                                                                               // Steuerlementvariablen mit IDs konfigurieren
        ButtonInit();                                                                               // Buttonfunktionalität konfigurieren
        SpinnerInit();                                                                              // Dropdown-Menüs konfigurieren
        Sichtbar(false);                                                                            // Unteren Teil des Layouts unsichtbar schalten
    }

    private void LayoutInit()                                                                       // Die einzelnen Steuerelemente als Variablen anlegen, damit sie bei Bedarf ausgelesen oder verändert werden können
    {
        editText_extern_i2c_eingabe = (EditText)findViewById(R.id.sensor_extern_i2c_eingabe);
        text_extern_i2c_sekunden = (TextView)findViewById(R.id.sensor_extern_i2c_sekunde);
        text_extern_i2c_sensor = (TextView)findViewById(R.id.sensor_extern_i2c_sensorauswahl);
        text_extern_i2c_typ = (TextView)findViewById(R.id.sensor_extern_i2c_typ);
        text_extern_i2c_anschluss = (TextView)findViewById(R.id.sensor_extern_i2c_portauswahl);
        text_extern_i2c_adresse = (TextView)findViewById(R.id.sensor_extern_i2c_adresse);
        editText_extern_i2c_adresse_eingabe = (EditText)findViewById(R.id.sensor_extern_i2c_adresse_eingabe);
        text_extern_i2c_wert = (TextView)findViewById(R.id.sensor_extern_i2c_wert);
        togglebutton_extern_i2c_freigeben = (ToggleButton)findViewById(R.id.sensor_extern_togglebutton);
        button_extern_i2c_automatisch = (Button)findViewById(R.id.sensor_extern_i2c_automatisch);
        button_extern_i2c_manuell = (Button)findViewById(R.id.sensor_extern_i2c_manuell);
        spinner_extern_i2c_typ = (Spinner)findViewById(R.id.spinner_i2c_typ);
        spinner_extern_i2c_portauswahl = (Spinner)findViewById(R.id.spinner_i2c_portauswahl);
        spinner_extern_i2c_sensorauswahl = (Spinner)findViewById(R.id.spinner_i2c_sensoren);
        button_extern_i2c_speichern = (Button)findViewById(R.id.sensor_extern_i2c_speichern);
    }

    private void ButtonInit()                                                                       // Buttons mit Funktionen hinterlegen
    {
        togglebutton_extern_i2c_freigeben.setOnClickListener(new View.OnClickListener()             // Wenn "Sensor ändern" gedrückt wird
        {
            public void onClick(View v)
            {
                button_extern_i2c_speichern.setEnabled(true);                                       // Einige Schaltflächen oben wieder aktivieren
                spinner_extern_i2c_sensorauswahl.setEnabled(true);
                spinner_extern_i2c_typ.setEnabled(true);
                spinner_extern_i2c_portauswahl.setEnabled(true);
                text_extern_i2c_sensor.setEnabled(true);
                text_extern_i2c_typ.setEnabled(true);
                text_extern_i2c_anschluss.setEnabled(true);
                editText_extern_i2c_adresse_eingabe.setEnabled(true);
                text_extern_i2c_adresse.setEnabled(true);

                Portanfrage = -1;                                                                   // Portanfrage löschen

                Sichtbar(false);                                                                    // Unteren Abfrageteil unsichtbar schalten -> Alles wieder auf Anfang
            }
        });

        button_extern_i2c_automatisch.setOnClickListener(new View.OnClickListener()                 // Wenn eine automatische Abfrage erfolgen soll
        {
            public void onClick(View v)
            {
                String str_Intervall = String.valueOf(editText_extern_i2c_eingabe.getText());       // Text auslesen wie oft abgefragt werden soll
                Integer Intervall = Integer.valueOf(str_Intervall);                                 // Intervall aus Text auslesen
                if((Intervall > 60000) || (Intervall < 500))                                        // Passt der in das Min/Max Intervall?
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_intervall_toast, Toast.LENGTH_SHORT).show();    // Wenn nicht -> Meldung anzeigen
                }
                else                                                                                // Wenn ja -> Wert abfragen
                {
                    button_extern_i2c_automatisch.setEnabled(false);                                // Abfragebuttons deaktivieren (es läuft ja gerade eine Abfrage)
                    editText_extern_i2c_eingabe.setEnabled(false);                                  // Eingaben unterbinden....
                    text_extern_i2c_sekunden.setEnabled(false);
                    togglebutton_extern_i2c_freigeben.setEnabled(false);
                    togglebutton_extern_i2c_freigeben.setChecked(false);

                    button_extern_i2c_manuell.setText(R.string.sensor_extern_i2c_stop);             // Start zu Stop Knopf machen

                    AbfrageAutomatisch();                                                           // Automatische Abfrage durchführen
                }
            }
        });

        button_extern_i2c_manuell.setOnClickListener(new View.OnClickListener() {                   // Manuelle Abfrage starten
            public void onClick(View v) {
                if (button_extern_i2c_manuell.getText() == getString(R.string.sensor_extern_i2c_stop))    // Wenn der Knopf grade als Stop Kopf für die Automatische Abfrage genutzt wird:
                {
                    button_extern_i2c_automatisch.setEnabled(true);                                 // Einige Schaltflächen wieder aktivieren
                    editText_extern_i2c_eingabe.setEnabled(true);
                    text_extern_i2c_sekunden.setEnabled(true);
                    button_extern_i2c_manuell.setText(R.string.sensor_extern_i2c_manuell_text);     // Stop Knopf wieder zum Start Knopf machen
                    togglebutton_extern_i2c_freigeben.setEnabled(true);
                    togglebutton_extern_i2c_freigeben.setChecked(true);

                    AutomatikHandler.removeCallbacks(mMyRunnable);                                  // Automatische Abfrage beenden
                }
                else                                                                                // Wenn der Knopf nicht als Stop Knopf genutzt wird
                {
                    I2CRead();                                                                      // Manuelle Abfrage durchführen
                }
            }
        });

        button_extern_i2c_speichern.setOnClickListener(new View.OnClickListener()                   // Wenn auf Initialisieren gedrückt wird
        {
            public void onClick(View v)
            {
                if(String.valueOf(spinner_extern_i2c_sensorauswahl.getSelectedItem()).equals("-Bitte auswählen-"))    // Kein Sensor ausgewählt
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_sensorauswahl_toast, Toast.LENGTH_SHORT).show();    // Meldung anzeigen
                }
                else if(String.valueOf(spinner_extern_i2c_portauswahl.getSelectedItem()).equals("-Bitte auswählen-"))    // Kein Port ausgewählt
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_portauswahl_toast, Toast.LENGTH_SHORT).show();    // Meldung anzeigen
                }
                else if(editText_extern_i2c_adresse_eingabe.getText().toString().equals(""))    // Keine Adresse ausgewählt
                {
                    Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_adresse_toast_leer, Toast.LENGTH_SHORT).show();    // Meldung anzeigen
                }
                else                                                                                // Initialisierung durchführen
                {
                    String str_Adresse = String.valueOf(editText_extern_i2c_adresse_eingabe.getText());
                    final Integer Adresse = Integer.valueOf(str_Adresse);                           // Adresse auslesen

                    if((Adresse % 2 == 0) && (Adresse <= 254) && (Adresse >= 2))                    // Schauen ob gültige Adresse vorliegt (nur gerade Nummer von 2 - 254) ( Siehe Ausarbeitung)
                    {
                        button_extern_i2c_speichern.setEnabled(false);                              // Oberen Schaltflächen deaktivieren
                        spinner_extern_i2c_sensorauswahl.setEnabled(false);
                        spinner_extern_i2c_typ.setEnabled(false);
                        spinner_extern_i2c_portauswahl.setEnabled(false);
                        text_extern_i2c_sensor.setEnabled(false);
                        text_extern_i2c_typ.setEnabled(false);
                        text_extern_i2c_anschluss.setEnabled(false);
                        editText_extern_i2c_adresse_eingabe.setEnabled(false);
                        text_extern_i2c_adresse.setEnabled(false);

                        Sichtbar(true);                                                             // Untere Schaltflächen (Abfrageteil) aktivieren und sichtbar machen
                        I2CConfig();                                                                // Konfiguration des I2C Bus durchführen
                    }
                    else
                    {
                        Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_adresse_toast, Toast.LENGTH_SHORT).show();  // Wenn Adresse nicht stimmt -> Meldung anzeigen
                    }
                }
            }
        });
    }

    private void KommandoEmpfangen(byte commandPacket[])                                            // Empfangenes Kommando untersuchen
    {
        if(commandPacket[0] == (byte)I2C_READ)                                                      // War es eine I2C Bus Abfrage?
        {
            if(commandPacket[1] == (byte)Portanfrage)                                               // War es der gewollte Port?
            {
                WertEintragen(WertZusammensetzen(commandPacket));                                   // Wenn ja: Dann Wert zusammensetzen und ausgeben
            }
            else
            {
                Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_error_port_toast, Toast.LENGTH_LONG).show();     // Wenn nicht ist ein Fehler unterlaufen: EIne Meldung wird angezeigt
            }
        }
        else
        {
            Toast.makeText(getApplicationContext(), R.string.sensor_extern_i2c_error_ad_toast, Toast.LENGTH_LONG).show();       // Wenn nicht ist ein Fehler unterlaufen: EIne Meldung wird angezeigt
        }
    }

    private int WertZusammensetzen(byte commandPacket[])                                            // Empfangenen Sensorwert aus 2 Byte in Int zusammenfügen
    {
        int Sensorwert = 0;

        Sensorwert = commandPacket[2]*256 + commandPacket[3];;                                      // Sensorwert zusammenfügen -> Warum genau so: Siehe Ausarbeitung

        return Sensorwert;                                                                          // fertigen Sensorwert zurückgeben
    }

    private double DoubleRunden(double wert, int stellen)                                           // Wert runden auf "stellen"-Stellen
    {
        double gerundet = Math.round(wert * Math.pow(10d, stellen));
        return gerundet / Math.pow(10d, stellen);
    }

    private void Sichtbar(boolean Zustand)                                                          // Unteren Abfrageteil (also die Schaltflächen) sichtbar oder unsichtbar schalten
    {
        int Sichtbarkeit = 0;
        if(Zustand == true){Sichtbarkeit = View.VISIBLE;}
        else{Sichtbarkeit = View.INVISIBLE;}

        ProgressBar mTrennstrich = (ProgressBar)findViewById(R.id.Trennstrich);
        mTrennstrich.setVisibility(Sichtbarkeit);
        TextView mAktualisierung = (TextView)findViewById(R.id.sensor_extern_i2c_aktualisierung);
        mAktualisierung.setVisibility(Sichtbarkeit);
        button_extern_i2c_automatisch.setVisibility(Sichtbarkeit);
        editText_extern_i2c_eingabe.setVisibility(Sichtbarkeit);
        text_extern_i2c_sekunden.setVisibility(Sichtbarkeit);
        button_extern_i2c_manuell.setVisibility(Sichtbarkeit);
        TextView mSensorwert = (TextView)findViewById(R.id.sensor_extern_i2c_sensorwert);
        mSensorwert.setVisibility(Sichtbarkeit);
        text_extern_i2c_wert.setVisibility(Sichtbarkeit);
        text_extern_i2c_wert.setText(R.string.sensor_extern_i2c_wert_text);
        togglebutton_extern_i2c_freigeben.setVisibility(Sichtbarkeit);
        togglebutton_extern_i2c_freigeben.setChecked(true);
    }

    private void AbfrageAutomatisch()                                                               // Automatische Abfrage durchführen
    {
        AutomatikHandler = new Handler();                                                           // Neuen Automatikhandler erstellen

        String str_Intervall = String.valueOf(editText_extern_i2c_eingabe.getText());
        final Integer Intervall = Integer.valueOf(str_Intervall);                                   // Intervall auslesen

        mMyRunnable = new Runnable()
        {
            public void run()
            {
                I2CRead();                                                                          // Alle x Millisekunden Abfrage durchführen
                AutomatikHandler.postDelayed(this, Intervall);                                      // Dann den Handler nach der Intervall-Zeit neustarten
            }
        };

        I2CRead();                                                                                  // Sensor abfragen, ansonsten wäre die erste Abfrage erst nach X Millisekunden
        AutomatikHandler.postDelayed(mMyRunnable, Intervall);                                       // Automatikbetrieb starten
    }

    private void I2CRead()                                                                          // I2C Bus abfragen
    {
        // Adresse auslesen
        String str_Adresse = String.valueOf(editText_extern_i2c_adresse_eingabe.getText());
        final Integer Adresse = Integer.valueOf(str_Adresse);

        // Schauen welcher Port genutzt wird und dementsprechendes Kommando senden
        if(String.valueOf(spinner_extern_i2c_portauswahl.getSelectedItem()).equals("SDA1")){KommandoSenden(I2C_READ, SDA_1, Adresse, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = SDA_1;}
        else if(String.valueOf(spinner_extern_i2c_portauswahl.getSelectedItem()).equals("SDA2")){KommandoSenden(I2C_READ, SDA_2, Adresse, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT); Portanfrage = SDA_2;}
    }

    private void I2CConfig()                                                                        // I2C Bus konfigurieren
    {
        // I2C Bus konfigurieren
        if(String.valueOf(spinner_extern_i2c_portauswahl.getSelectedItem()).equals("SDA1")){KommandoSenden(I2C_CONFIG, SDA_1, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
        else if(String.valueOf(spinner_extern_i2c_portauswahl.getSelectedItem()).equals("SDA2")){KommandoSenden(I2C_CONFIG, SDA_2, AKTIV, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);}
    }

    //für USB:--------------------------------------------------------------------------------

    public void onPause()                                                                           // Wenn die App pausiert /minimiert wird
    {
        KommandoSenden(APP_DISCONNECT,UNBENUTZT,UNBENUTZT,UNBENUTZT,UNBENUTZT,UNBENUTZT, UNBENUTZT, UNBENUTZT);     // Dem Mikrocontroller mitteilen, dass er in "Standbye" gehen kann

        try{while(accessoryManager.isClosed() == false){Thread.sleep(500);}}                        // Warten bis der Accessory Manager geschlossen wird
        catch(InterruptedException e){e.printStackTrace();}                                         // Wenn das nicht geklappt hat -> Fehler ausgeben

        super.onPause();                                                                            // Programm pausieren
        accessoryManager.disable(this);                                                             // AccessoryManager ausschalten
        disconnectAccessory();                                                                      // Verbindung trennen
    }
    public void onResume()                                                                          // Wenn Programm wieder geöffnet wird
    {
        super.onResume();                                                                           // Program starten
        accessoryManager.enable(this, getIntent());                                                 // Accessory Manager wieder starten
    }
    private void TitelVerbunden(boolean verbunden)                                                  // Titel ändern wenn Board verbunden oder getrennt wird
    {
        TextView text_board_ueberschrift;
        text_board_ueberschrift=(TextView)findViewById(R.id.extern_i2c_titel);
        if(verbunden == true)                                                                       // Wenn verbunden -> dann auch hinschreiben und grün unterlegen
        {
            text_board_ueberschrift.setText(R.string.extern_activity_verbunden);
            text_board_ueberschrift.setBackgroundColor(Color.GREEN);
            button_extern_i2c_speichern.setEnabled(true);                                           // Initialisierenknopf kann gedrückt werden
        }
        else
        {
            text_board_ueberschrift.setText(R.string.extern_activity_nichtverbunden);               // Wenn nicht -> hinschreiben und rot machen
            text_board_ueberschrift.setBackgroundColor(Color.RED);

            if (button_extern_i2c_manuell.getText() == getString(R.string.sensor_extern_i2c_stop))  // Wenn der Stecker gezogen wird obwohl eine Abfrage läuft: Automatische Abfrage stoppen
            {
                button_extern_i2c_automatisch.setEnabled(true);                                     // Alles wieder auf Anfang, richtige Buttons einschalten
                editText_extern_i2c_eingabe.setEnabled(true);
                text_extern_i2c_sekunden.setEnabled(true);
                button_extern_i2c_manuell.setText(R.string.sensor_extern_i2c_manuell_text);
                togglebutton_extern_i2c_freigeben.setEnabled(true);
                togglebutton_extern_i2c_freigeben.setChecked(true);

                AutomatikHandler.removeCallbacks(mMyRunnable);
            }

            button_extern_i2c_speichern.setEnabled(true);
            spinner_extern_i2c_sensorauswahl.setEnabled(true);
            spinner_extern_i2c_typ.setEnabled(true);
            spinner_extern_i2c_portauswahl.setEnabled(true);
            text_extern_i2c_sensor.setEnabled(true);
            text_extern_i2c_typ.setEnabled(true);
            text_extern_i2c_anschluss.setEnabled(true);
            editText_extern_i2c_adresse_eingabe.setEnabled(true);
            text_extern_i2c_adresse.setEnabled(true);

            Sichtbar(false);                                                                        // Unteren Teil wieder unsichtbar schalten

            button_extern_i2c_speichern.setEnabled(false);                                          // Intitialisieren-Knopf kann nicht gedrückt werden bis wieder verbunden wird
        }
    }
    private void disconnectAccessory()                                                              // Accessory disconnecten
    {
        if(deviceAttached == false){return;}
        TitelVerbunden(false);
    }
    private void KommandoSenden(int Typ, int Port, int Wert1, int Wert2, int Wert3, int Wert4, int Wert5, int Wert6)    // Senden eines Kommandos an den Mikrocontroller
    {
        byte[] commandPacket = new byte[8];
        commandPacket[0] = (byte) Typ;                                                              // Kommandotyp
        commandPacket[1] = (byte) Port;                                                             // Gewünschter Kanal / Port
        commandPacket[2] = (byte) Wert1;                                                            // z.B. die Adresse des Sensors
        commandPacket[3] = (byte) Wert2;                                                            // ...
        commandPacket[4] = (byte) Wert3;                                                            // Unbenutzt
        commandPacket[5] = (byte) Wert4;                                                            // Unbenutzt
        commandPacket[6] = (byte) Wert5;                                                            // Unbenutzt
        commandPacket[7] = (byte) Wert6;                                                            // Unbenutzt

        accessoryManager.write(commandPacket);                                                      // Datenpaket senden
    }

    private Handler handler = new Handler()                                                         // USB-Handler (kümmert sich um die Kommunikation mit dem Board)
    {
        public void handleMessage(Message msg)                                                      // Wenn eine neue Nachricht reinkommt
        {
            byte[] commandPacket = new byte[8];                                                     // Datenpaket anlegen

            switch(msg.what)                                                                        // Was war es für ein Kommando
            {
                case USBAccessoryWhat:                                                              // Welcher Inhalt
                    switch(((USBAccessoryManagerMessage)msg.obj).type)
                    {
                        case READ:                                                                  // Es war ein Read-Kommando vom Board
                            if(accessoryManager.isConnected() == false){return;}                    // Wenn nicht verbunden ist -> egal

                            while(true)
                            {
                                if(accessoryManager.available() < 8){break;}                        // Alle Kommandos sind 8 Byte lang -> Was kürzeres war ein unvollständiges Kommando

                                accessoryManager.read(commandPacket);                               // Kommando vom USB Handler abfragen

                                KommandoEmpfangen(commandPacket);                                   // Kommando analysieren
                            }break;

                        case CONNECTED:	break;                                                      // Wenn gesagt wird, dass verbunden wurde -> weitermachen

                        case READY:                                                                 // Wenn das Board sagt, dass es bereit zum verbinden ist -> Verbinden Kommando senden
                            deviceAttached = true;
                            TitelVerbunden(true);                                                   // Titel ändern
                            KommandoSenden(APP_CONNECT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT, UNBENUTZT);   // Kommando senden
                            break;

                        case DISCONNECTED:                                                          // Wenn es ein Disconnect vom Board war -> Verbindung trennen
                            disconnectAccessory();
                            break;
                    }break;

                default: break;
            }	//switch
        } //handleMessage
    }; //handler


    // ------------ Menü ----------------- Kommentare siehe StartActivity

    public boolean onCreateOptionsMenu(Menu menu)
    {
        getMenuInflater().inflate(R.menu.menu_klein, menu);
        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item)
    {
        switch (item.getItemId())
        {
            case R.id.action_info:
                Info();
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void Info()
    {
        AlertDialog alertDialog = new AlertDialog.Builder(this).create();
        alertDialog.setTitle("INFO");
        alertDialog.setMessage(getString(R.string.menue_info_text));
        alertDialog.setButton("OK", new DialogInterface.OnClickListener()
        {public void onClick(DialogInterface dialog, int which) {}});
        alertDialog.show();
    }
}
