package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.Vibrator;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.util.List;

public class MenueActivity extends ActionBarActivity
{
	public final static String EXTRA_MESSAGE = "com.tuhh.mikrosystem.handysensoren.MESSAGE";
	public static int Beschleunigung_vorhanden = -1;                                                // Übeergabe an die Bescdhleunigungs-Acitivty: 0=beide, 1=nur g, 2=nur lin
    private int HiddenMenueStart = 0;                                                               // Wenn alle Tasten entriegelt werden sollen -> 3x unten auf den Schriftzug drücken, es vibriert dann leicht

	private Sensor                                                                                  // Sensorvariablen anlegen
			s_Beschleunigung_g = null, s_Beschleunigung_lin = null,
            s_Gerätetemperatur = null, s_Gravitation = null, s_Gyroskop = null,
			s_Licht = null, s_Luftdruck = null, s_MagFeld = null,
			s_Naeherung = null, s_Orientierung = null, s_Puls = null,
			s_RelFeuchtigkeit = null, s_RotationsVektor = null, s_Schritt = null,
			s_Schritt_Anzahl = null, s_Umgebungstemperatur = null;

	private Button                                                                                  // Buttonvariablen anlegen
			button_menue_kamera = null, button_menue_beschleunigung = null,
			button_menue_gyroskop = null, button_menue_rotationsvektor = null,
			button_menue_orientierung = null, button_menue_gravitation = null,
			button_menue_magFeld = null, button_menue_naeherung = null,
			button_menue_temperatur = null, button_menue_luftdruck = null,
			button_menue_relFeuchtigkeit = null, button_menue_licht = null,
			button_menue_bildschirm = null, button_menue_schritt = null,
			button_menue_puls = null, button_menue_akku = null, button_menue_gps = null,
			button_menue_kompass = null;

    private Vibrator vibe = null;                                                                   // Vibrationsmotorvariable für das versteckte entriegeln der Buttons anlegen

	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_menue);                                                    // Layout starten

		ButtonInit();                                                                               // Buttons anlegen und mit Funktionen belegen
		SensorInit();                                                                               // Sensoren überprüfen welche es gibt

        vibe = (Vibrator) MenueActivity.this.getSystemService(Context.VIBRATOR_SERVICE);            // Vibrationsmotor initialisieren
	}

	private void ButtonInit()
	{
		button_menue_kamera = (Button) findViewById(R.id.menue_button_kamera);                      // Buttonvariablen mit IDs füllen
		button_menue_gps = (Button) findViewById(R.id.menue_button_gps);
		button_menue_beschleunigung = (Button) findViewById(R.id.menue_button_beschleunigung);
		button_menue_gyroskop = (Button) findViewById(R.id.menue_button_gyroskop);
		button_menue_rotationsvektor = (Button) findViewById(R.id.menue_button_rotationsvektor);
		button_menue_orientierung = (Button) findViewById(R.id.menue_button_orientierung);
		button_menue_gravitation = (Button) findViewById(R.id.menue_button_gravitation);
		button_menue_magFeld = (Button) findViewById(R.id.menue_button_magFeld);
		button_menue_naeherung = (Button) findViewById(R.id.menue_button_naeherung);
		button_menue_temperatur = (Button) findViewById(R.id.menue_button_temperatur);
		button_menue_luftdruck = (Button) findViewById(R.id.menue_button_luftdruck);
		button_menue_relFeuchtigkeit = (Button) findViewById(R.id.menue_button_relFeuchtigkeit);
		button_menue_licht = (Button) findViewById(R.id.menue_button_licht);
		button_menue_bildschirm = (Button) findViewById(R.id.menue_button_bildschirm);
		button_menue_schritt = (Button) findViewById(R.id.menue_button_schritt);
		button_menue_puls = (Button) findViewById(R.id.menue_button_puls);
		button_menue_akku = (Button) findViewById(R.id.menue_button_akku);
		button_menue_kompass = (Button) findViewById(R.id.menue_button_kompass);

        final TextView HiddenMenue = (TextView)findViewById(R.id.menue_text_hinweis);               // versteckte Aktivierung aller Buttons aktivieren
        HiddenMenue.setOnLongClickListener(new View.OnLongClickListener()                           // dafür ein OnLongClickListener anlegen
        {
            public boolean onLongClick(View v)                                                      // Wenn ein langer Druck erkannt wurde
            {
                if(HiddenMenueStart == 2)                                                           // Wenn es 3 (!) mal lang gedrückt wurde
                {
                    button_menue_kamera.setEnabled(true);                                           // Alle Buttons aktivieren
                    button_menue_gps.setEnabled(true);
                    button_menue_beschleunigung.setEnabled(true);
                    button_menue_gyroskop.setEnabled(true);
                    button_menue_rotationsvektor.setEnabled(true);
                    button_menue_orientierung.setEnabled(true);
                    button_menue_kompass.setEnabled(true);
                    button_menue_gravitation.setEnabled(true);
                    button_menue_magFeld.setEnabled(true);
                    button_menue_temperatur.setEnabled(true);
                    button_menue_naeherung.setEnabled(true);
                    button_menue_luftdruck.setEnabled(true);
                    button_menue_relFeuchtigkeit.setEnabled(true);
                    button_menue_licht.setEnabled(true);
                    button_menue_schritt.setEnabled(true);
                    button_menue_puls.setEnabled(true);
                    button_menue_akku.setEnabled(true);
                    button_menue_bildschirm.setEnabled(true);

                    button_menue_kamera.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(0);}});             // Und auch für alle den OnClickListener anlegen sonst wird kein Layout gestartet
                    button_menue_gps.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(1);}});
                    button_menue_beschleunigung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(2);}});
                    button_menue_gyroskop.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(3);}});
                    button_menue_rotationsvektor.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(4);}});
                    button_menue_orientierung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(5);}});
                    button_menue_gravitation.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(6);}});
                    button_menue_kompass.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(17);}});
                    button_menue_magFeld.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(7);}});
                    button_menue_naeherung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(8);}});
                    button_menue_temperatur.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(9);}});
                    button_menue_relFeuchtigkeit.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(11);}});
                    button_menue_luftdruck.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(10);}});
                    button_menue_licht.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(12);}});
                    button_menue_schritt.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(14);}});
                    button_menue_puls.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(15);}});
                    button_menue_akku.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(16);}});
                    button_menue_bildschirm.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(13);}});

                    View vg = findViewById (R.id.layout_menue);                                     // Layout refreshen lassen
                    vg.invalidate();                                                                //      ||
                }
                else                                                                                // Wenn nicht dreimal gedrückt wurde
                {
                    HiddenMenueStart++;                                                             // Zähler hochsetzen
                    vibe.vibrate(50);                                                               // kurz vibrieren
                }
                return false;
            }
        });
	}

	private void SensorInit()
	{
		SensorManager sensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);     // Sensormanager anlegen
		List<Sensor> SensorenListe = sensorManager.getSensorList(Sensor.TYPE_ALL);                  // Sensorliste mit allen verfügbaren Sensoren anlegen

		for(Sensor s : SensorenListe)                                                               // Sensorliste durchgehen
		{
			switch(s.getType())                                                                     // Schauen welcher Sensor implementiert ist
			{
				case Sensor.TYPE_ACCELEROMETER: s_Beschleunigung_g = s; break;                      // Wenn ein Sensor verfügbar ist -> mit ID füllen
				case Sensor.TYPE_LINEAR_ACCELERATION: s_Beschleunigung_lin = s; break;
				case Sensor.TYPE_TEMPERATURE: s_Gerätetemperatur = s; break;
				case Sensor.TYPE_GRAVITY: s_Gravitation = s; break;
				case Sensor.TYPE_GYROSCOPE: s_Gyroskop = s; break;
				case Sensor.TYPE_LIGHT: s_Licht = s; break;
				case Sensor.TYPE_PRESSURE: s_Luftdruck = s; break;
				case Sensor.TYPE_MAGNETIC_FIELD: s_MagFeld = s; break;
				case Sensor.TYPE_PROXIMITY: s_Naeherung = s; break;
				case Sensor.TYPE_ORIENTATION: s_Orientierung = s; break;
				case Sensor.TYPE_HEART_RATE: s_Puls = s; break;
				case Sensor.TYPE_RELATIVE_HUMIDITY: s_RelFeuchtigkeit = s; break;
				case Sensor.TYPE_ROTATION_VECTOR: s_RotationsVektor = s; break;
				case Sensor.TYPE_STEP_DETECTOR: s_Schritt = s; break;
				case Sensor.TYPE_STEP_COUNTER: s_Schritt_Anzahl = s; break;
				case Sensor.TYPE_AMBIENT_TEMPERATURE: s_Umgebungstemperatur = s; break;
			}
		}
		Context context = this;
		PackageManager packageManager = context.getPackageManager();                                // Für Systemkomponenten muss der Paketmanager abgefragt werden (Kamera, Bildschirm, Akku, Mikro)
		if(packageManager.hasSystemFeature(PackageManager.FEATURE_CAMERA) == true)                  // Wenn Kamera vorhanden ist dann auch Mikro
		{
			button_menue_kamera.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(0);}});                     // Button mit Funktion versehen (neues Layout starten)
			button_menue_kamera.setEnabled(true);                                                   // Button aktivieren
		}
		if(packageManager.hasSystemFeature(PackageManager.FEATURE_LOCATION_GPS) == true)            // Wenn GPS vorhanden ist
		{
			button_menue_gps.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(1);}});
			button_menue_gps.setEnabled(true);
		}
		if((s_Beschleunigung_g != null) || (s_Beschleunigung_lin != null))                          // Wenn einer der Beschleunigungssensoren vorhanden ist, dann Button aktivieren
		{
			button_menue_beschleunigung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(2);}});             // Und mit Funktion hinterlegen
			button_menue_beschleunigung.setEnabled(true);

			if((s_Beschleunigung_g != null) && (s_Beschleunigung_lin != null)){Beschleunigung_vorhanden=0;}
			else if(s_Beschleunigung_g != null){Beschleunigung_vorhanden=1;}                        // In die Activity übergeben welcher der Sensoren verbaut ist -> Activity wird entsprechend angepasst
			else if(s_Beschleunigung_lin != null){Beschleunigung_vorhanden=2;}
		}
		if(s_Gyroskop != null)
		{
			button_menue_gyroskop.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(3);}});
			button_menue_gyroskop.setEnabled(true);
		}
		if(s_RotationsVektor != null)
		{
			button_menue_rotationsvektor.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(4);}});
			button_menue_rotationsvektor.setEnabled(true);
		}
		if(s_Orientierung != null)                                                                  // Wenn Orientierungssensor verfügbar ist, auch den Kompass-Kopf aktivieren -> ist der gleiche Sensor
		{
			button_menue_orientierung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(5);}});
			button_menue_orientierung.setEnabled(true);

			button_menue_kompass.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(17);}});
			button_menue_kompass.setEnabled(true);
		}
		if(s_Gravitation != null)
		{
			button_menue_gravitation.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(6);}});
			button_menue_gravitation.setEnabled(true);
		}
		if(s_MagFeld != null)
		{
			button_menue_magFeld.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(7);}});
			button_menue_magFeld.setEnabled(true);
		}
		if(s_Naeherung != null)
		{
			button_menue_naeherung.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(8);}});
			button_menue_naeherung.setEnabled(true);
		}
		if((s_Gerätetemperatur != null)||(s_Umgebungstemperatur != null))                           // Wenn ein Temperatursensor verfügbar ist -> Button aktivieren
		{
            if((s_Gerätetemperatur != null)&&(s_Umgebungstemperatur != null)){button_menue_temperatur.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(9);}});}
            if((s_Gerätetemperatur == null)&&(s_Umgebungstemperatur != null)){button_menue_temperatur.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(18);}});}
            if((s_Gerätetemperatur != null)&&(s_Umgebungstemperatur == null)){button_menue_temperatur.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(19);}});}
			button_menue_temperatur.setEnabled(true);                                               // In die Activity übergeben welcher der Sensoren verbaut ist -> Activity wird entsprechend angepasst
		}
		if(s_Luftdruck != null)
		{
			button_menue_luftdruck.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(10);}});
			button_menue_luftdruck.setEnabled(true);
		}
		if(s_RelFeuchtigkeit != null)
		{
			button_menue_relFeuchtigkeit.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(11);}});
			button_menue_relFeuchtigkeit.setEnabled(true);
		}
		if(s_Licht != null)
		{
			button_menue_licht.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(12);}});
			button_menue_licht.setEnabled(true);
		}
		if((s_Schritt != null) || (s_Schritt_Anzahl != null))
		{
			button_menue_schritt.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(14);}});
			button_menue_schritt.setEnabled(true);
		}
		if(s_Puls != null)
		{
			button_menue_puls.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(15);}});
			button_menue_puls.setEnabled(true);
		}
		button_menue_akku.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(16);}});                          // Akku ist immer verfügbar
		button_menue_akku.setEnabled(true);
        button_menue_bildschirm.setOnClickListener(new View.OnClickListener(){public void onClick(View v){ButtonAuswahl(13);}});                    // Bildschirm ist immer verfügbar
        button_menue_bildschirm.setEnabled(true);
	}

	private void ButtonAuswahl(int Auswahl)
	{
		switch(Auswahl)                                                                             // Je nach Knopfdruck die passende Activity starten
		{
			case 0: Kamerasensor(); break;                                                          // Kamera
			case 1: GPSsensor(); break;                                                             // GPS
			case 2: Beschleunigungssensor(Beschleunigung_vorhanden); break;                         // Beschleunigung_g, Beschleunigung_lin
			case 3: Spezialsensor(Auswahl); break;                                                  // Gyroskop
			case 4: Spezialsensor(Auswahl); break;                                                  // RotVektor
			case 5: Orientierungssensor(); break;                                                   // Orientation
			case 6: Spezialsensor(Auswahl); break;                                                  // Gravitation
			case 7: Spezialsensor(Auswahl); break;                                                  // Mag Feld
			case 8: Standardsensor(Auswahl); break;                                                 // Näherung
			case 9: Standardsensor(Auswahl); break;                                                 // Temperatur
			case 10: Standardsensor(Auswahl); break;                                                // Luftdruck
			case 11: Standardsensor(Auswahl); break;                                                // Feuchtigkeit
			case 12: Standardsensor(Auswahl); break;                                                // Licht
			case 13: Bildschirmsensor(); break;                                                     // Bildschirm
			case 14: Schrittsensor(); break; 		                                                // Schritt und Schritt Anzahl
			case 15: Standardsensor(Auswahl); break;                                                // Puls
			case 16: Akkusensor(); break; 			                                                // Akku
			case 17: Kompasssensor(); break;                                                        // Kompass
            case 18: Standardsensor(18); break;                                                     // Nur Umgebungstemp
            case 19: Standardsensor(19); break;                                                     // Nur Gerätetemp
		}
	}

    // Nicht jeder Sensor hat seine eigene Activity -> Manche sind mehrfach belegt und werden nur dem jeweiligen Sensor angepasst

    private void Bildschirmsensor()
    {
        Intent intent = new Intent(this, SensorActivity_Bildschirm.class);
        startActivity(intent);
    }

	private void GPSsensor()
	{
		Intent intent = new Intent(this, SensorActivity_GPS.class);
		startActivity(intent);
	}

	private void Akkusensor()
	{
		Intent intent = new Intent(this, SensorActivity_Akku.class);
		startActivity(intent);
	}

	private void Kompasssensor()
	{
		Intent intent = new Intent(this, SensorActivity_Kompass.class);
		startActivity(intent);
	}

	private void Kamerasensor()
	{
		Intent intent = new Intent(this, SensorActivity_Kamera.class);
		startActivity(intent);
	}

	private void Schrittsensor()
	{
		Intent intent = new Intent(this,SensorActivity_Schritt.class);
		startActivity(intent);
	}

	private void Orientierungssensor()
	{
		Intent intent = new Intent(this,SensorActivity_Orientierung.class);
		startActivity(intent);
	}

	private void Beschleunigungssensor(int vorhanden)
	{
		Intent intent = new Intent(this,SensorActivity_Beschleunigung.class);
		String message = String.valueOf(vorhanden);
		intent.putExtra(MenueActivity.EXTRA_MESSAGE, message);
		startActivity(intent);
	}

	private void Standardsensor(int Auswahl)
	{
		Intent intent = new Intent(this, SensorActivity_Standard.class);
		String message = String.valueOf(Auswahl);
		intent.putExtra(MenueActivity.EXTRA_MESSAGE, message);
		startActivity(intent);
	}

	private void Spezialsensor(int Auswahl)
	{
		Intent intent = new Intent(this, SensorActivity_Spezial.class);
		String message = String.valueOf(Auswahl);
		intent.putExtra(MenueActivity.EXTRA_MESSAGE, message);
		startActivity(intent);
	}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Wieder das Menü anlegen -> Kommentare siehe StartActivity
	{
		getMenuInflater().inflate(R.menu.menu_gross, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			case R.id.action_beenden:
				this.finish();
				Intent intent = new Intent(Intent.ACTION_MAIN);
				intent.addCategory(Intent.CATEGORY_HOME);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				startActivity(intent);
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
