package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.BatteryManager;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class SensorActivity_Akku extends ActionBarActivity
{
	// Steuerelementvariablen anlegen
    private TextView
			 text_sensor_akku_ladestand = null, text_sensor_akku_typ = null,
			 text_sensor_akku_eingesteckt = null, text_sensor_akku_gesundheit = null,
			 text_sensor_akku_status = null, text_sensor_akku_spannung = null,
			 text_sensor_akku_temperatur = null, text_sensor_akku_eingelegt = null;

	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_akku);                                              // Layout starten

		text_sensor_akku_ladestand = (TextView) findViewById(R.id.sensor_akku_text_ladestand);      // Sensorvariablen mit ID füllen
		text_sensor_akku_typ = (TextView) findViewById(R.id.sensor_akku_text_typ);
		text_sensor_akku_eingesteckt = (TextView) findViewById(R.id.sensor_akku_text_eingesteckt);
		text_sensor_akku_gesundheit = (TextView) findViewById(R.id.sensor_akku_text_gesundheit);
		text_sensor_akku_status = (TextView) findViewById(R.id.sensor_akku_text_status);
		text_sensor_akku_spannung = (TextView) findViewById(R.id.sensor_akku_text_spannung);
		text_sensor_akku_temperatur = (TextView) findViewById(R.id.sensor_akku_text_temperatur);
		text_sensor_akku_eingelegt = (TextView) findViewById(R.id.sensor_akku_text_eingelegt);
		Button button_akku_sensoruebersicht = (Button) findViewById(R.id.sensor_akku_button_sensoruebersicht);

		button_akku_sensoruebersicht.setOnClickListener(new View.OnClickListener()
        {
			public void onClick(View v)
            {
				Sensoruebersicht();                                                                 // Wenn auf den Sensorübersichts Button gedrückt wird -> neues Layout starten
			}
		});

		registerBatteryLevelReceiver();                                                             // BatteryReceiver registrieren -> dieser bringt die aktuellen Infos über den Akku
	}

	private void Sensoruebersicht()                                                                 // anderes Layout starten -> Siehe SensorActivity_Sensorübersicht Activity
	{
		Intent intent = new Intent(this,SensorActivity_Sensoruebersicht.class);
		startActivity(intent);
	}

	private void registerBatteryLevelReceiver()                                                     // Den Receiver im System registrieren
	{
		IntentFilter filter = new IntentFilter(Intent.ACTION_BATTERY_CHANGED);                      // Event auslösen wenn sich ein Wert am Akku ändert
		registerReceiver(battery_receiver, filter);                                                 // starten
	}

	private BroadcastReceiver battery_receiver = new BroadcastReceiver()
	{
		public void onReceive(Context context, Intent intent)                                       // Wenn dieses Event eintrifft
		{
			// Die einzelnen Werte auslesen und dementsprechend im Layout eintragen
            // Der Ladestand muss über den Maximalwert und den jetzigen Wert in Prozent ausgerechnet werden
            // Sonst wird der Akku nur jeweils auf Parameter überprüft dann das passende Wort hingeschrieben

            if(intent.getBooleanExtra("present", false) == true){text_sensor_akku_eingelegt.setText(R.string.sensor_akku_text_eingelegt_ja);}
			else{text_sensor_akku_eingelegt.setText(R.string.sensor_schritt_text_nein); return;}

			int scale = intent.getIntExtra("scale", -1);
			int rawlevel = intent.getIntExtra("level", -1);
			int level = 0;
			if (rawlevel >= 0 && scale > 0) {level = (rawlevel * 100) / scale;}
			text_sensor_akku_ladestand.setText(getString(R.string.sensor_akku_text_ladestand) + " " +  level + " " + getString(R.string.sensor_akku_text_ladestand_einheit));

			text_sensor_akku_typ.setText(getString(R.string.sensor_akku_text_typ) + " " + intent.getStringExtra("technology"));

			if(intent.getIntExtra("plugged", -1) == BatteryManager.BATTERY_PLUGGED_AC){text_sensor_akku_eingesteckt.setText(R.string.sensor_akku_text_angeschlossen_netzteil);}
			else if(intent.getIntExtra("plugged", -1) == BatteryManager.BATTERY_PLUGGED_USB){text_sensor_akku_eingesteckt.setText(R.string.sensor_akku_text_angeschlossen_usb);}
			else if(intent.getIntExtra("plugged", -1) == BatteryManager.BATTERY_PLUGGED_WIRELESS){text_sensor_akku_eingesteckt.setText(R.string.sensor_akku_text_angeschlossen_kabellos);}
			else {text_sensor_akku_eingesteckt.setText(R.string.sensor_akku_text_angeschlossen_nichts);}

			if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_COLD){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_kalt);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_DEAD){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_kaputt);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_GOOD){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_gut);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_OVERHEAT){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_ueberhitzt);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_OVER_VOLTAGE){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_ueberspannung);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_UNKNOWN){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_unbekannt);}
			else if(intent.getIntExtra("health", 0) == BatteryManager.BATTERY_HEALTH_UNSPECIFIED_FAILURE){text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_fehler);}
			else {text_sensor_akku_gesundheit.setText(R.string.sensor_akku_text_gesundheit_unbekannt);}

			if(intent.getIntExtra("status", 0) == BatteryManager.BATTERY_STATUS_CHARGING){text_sensor_akku_status.setText(R.string.sensor_akku_text_status_laedt);}
			else if(intent.getIntExtra("status", 0) == BatteryManager.BATTERY_STATUS_DISCHARGING){text_sensor_akku_status.setText(R.string.sensor_akku_text_status_entlaedt);}
			else if(intent.getIntExtra("status", 0) == BatteryManager.BATTERY_STATUS_FULL){text_sensor_akku_status.setText(R.string.sensor_akku_text_status_aufgeladen);}
			else if(intent.getIntExtra("status", 0) == BatteryManager.BATTERY_STATUS_NOT_CHARGING){text_sensor_akku_status.setText(R.string.sensor_akku_text_status_laedtnicht);}
			else if(intent.getIntExtra("status", 0) == BatteryManager.BATTERY_STATUS_UNKNOWN){text_sensor_akku_status.setText(R.string.sensor_akku_text_status_unbekannt);}
			else {text_sensor_akku_status.setText(R.string.sensor_akku_text_status_unbekannt);}

			text_sensor_akku_spannung.setText(getString(R.string.sensor_akku_text_spannung) + " " + intent.getIntExtra("voltage", 0) + " " + getString(R.string.sensor_akku_text_spannung_einheit));

			Integer Temperatur = new Integer(intent.getIntExtra("temperature", 0));
			String sTemperatur = Temperatur.toString();
			sTemperatur = new StringBuffer(sTemperatur).insert(sTemperatur.length()-1, ".").toString();
			text_sensor_akku_temperatur.setText(getString(R.string.sensor_akku_text_temperatur) + " " + sTemperatur + " " + getString(R.string.sensor_akku_text_temperatur_einheit));
		}
	};

	public void onResume()                                                                          // Wenn die App minimiert wird
	{
		super.onResume();
		registerBatteryLevelReceiver();                                                             // Receiver abschalten, damit nicht weiterhin Events ausgelöst werden
	}

	public void onPause()                                                                           // Wenn die App wieder maximiert wird
	{
		super.onPause();
		unregisterReceiver(battery_receiver);                                                       // Receiver wieder einschalten, es werden wieder Events abgefangen
	}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Wieder Menü anlegen -> Kommis siehe andere Activity
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
