package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

import android.os.CountDownTimer;
import android.os.Environment;
import android.media.MediaRecorder;
import android.media.MediaPlayer;
import android.widget.TextView;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class SensorActivity_Kamera extends ActionBarActivity
{
	private ImageView
			image_sensor_standard_kamera = null;

	public static final int CAMERA_REQUEST_CODE = 10;

    private MediaPlayer mPlayer = null;
    private MediaRecorder mRecorder = null;
    private static String mFileName = null;

    private boolean mStartRecording = true;
    private boolean mStartPlaying = true;
    private long Startzeit;
    private long Aufnahmezeit;
    CountDownTimer CountDown;

    private Button button_sensor_mikrofon_aufnahme = null, button_sensor_mikrofon_abspielen = null;

	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_kamera);

		Button button_sensor_kamera_neuesfoto = (Button) findViewById(R.id.sensor_kamera_button_foto);
		button_sensor_kamera_neuesfoto.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				startCamera();
			}
		});
		image_sensor_standard_kamera = (ImageView)findViewById(R.id.sensor_kamera_image_foto);

        ButtonsInitialisieren();
	}

	private void startCamera()
	{
		Intent cameraIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		startActivityForResult(cameraIntent, CAMERA_REQUEST_CODE);
	}

	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		super.onActivityResult(requestCode, resultCode, data);

		if (resultCode == RESULT_OK) // OK gedrückt?
		{
			if (requestCode == CAMERA_REQUEST_CODE)
			{
				// Kamera ist fertig
				Bitmap cameraImage = (Bitmap) data.getExtras().get("data");
				// Daten = Bild kommt zurück
                TextView sensor_kamera_hinweis = (TextView)findViewById(R.id.sensor_kamera_hinweis_text);
                sensor_kamera_hinweis.setVisibility(View.INVISIBLE);
                button_sensor_mikrofon_abspielen.setEnabled(false);

				image_sensor_standard_kamera.setImageBitmap(cameraImage);
			}
		}
	}

// - Mikrofon

    public String Uhrzeit()
    {
        String now = new SimpleDateFormat("yyyy.MM.dd_HH:mm:ss").format(new Date());
        return now;
    }

    private void ButtonsInitialisieren()
    {
        button_sensor_mikrofon_aufnahme = (Button)findViewById(R.id.sensor_kamera_mikrofon_aufnahme);
        button_sensor_mikrofon_abspielen = (Button)findViewById(R.id.sensor_kamera_mikrofon_abspielen);

        button_sensor_mikrofon_aufnahme.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View v)
            {
                onRecord(mStartRecording);
                if (mStartRecording == true)
                {
                    button_sensor_mikrofon_aufnahme.setText(R.string.sensor_kamera_mikrofon_aufnahme_stoppen);
                    button_sensor_mikrofon_abspielen.setEnabled(false);

                    Startzeit = System.currentTimeMillis();

                    Button KameraButton = (Button)findViewById(R.id.sensor_kamera_button_foto);
                    KameraButton.setEnabled(false);
                }
                else
                {
                    button_sensor_mikrofon_aufnahme.setText(R.string.sensor_kamera_mikrofon_aufnahme_starten);
                    button_sensor_mikrofon_abspielen.setEnabled(true);

                    Aufnahmezeit = System.currentTimeMillis() - Startzeit;
                    Startzeit = System.currentTimeMillis();

                    Button KameraButton = (Button)findViewById(R.id.sensor_kamera_button_foto);
                    KameraButton.setEnabled(true);
                }
                mStartRecording = !mStartRecording;
            }
        });
        button_sensor_mikrofon_abspielen.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View v)
            {
                onPlay(mStartPlaying);
                if (mStartPlaying)
                {
                    button_sensor_mikrofon_abspielen.setText(R.string.sensor_kamera_mikrofon_wiedergabe_stoppen);
                    button_sensor_mikrofon_aufnahme.setEnabled(false);

                    Button KameraButton = (Button)findViewById(R.id.sensor_kamera_button_foto);
                    KameraButton.setEnabled(false);

                    //Handler starten

                    CountDown = new CountDownTimer(Aufnahmezeit, 1000)
                    {
                        public void onTick(long millisUntilFinished){}
                        public void onFinish()
                        {
                            onPlay(mStartPlaying);
                            button_sensor_mikrofon_abspielen.setText(R.string.sensor_kamera_mikrofon_wiedergabe_starten);
                            button_sensor_mikrofon_aufnahme.setEnabled(true);
                            mStartPlaying = !mStartPlaying;
                            Button KameraButton = (Button)findViewById(R.id.sensor_kamera_button_foto);
                            KameraButton.setEnabled(true);
                        }
                    };
                    CountDown.start();
                }
                else
                {
                    button_sensor_mikrofon_abspielen.setText(R.string.sensor_kamera_mikrofon_wiedergabe_starten);
                    button_sensor_mikrofon_aufnahme.setEnabled(true);

                    //Handler beenden

                    CountDown.cancel();

                    Button KameraButton = (Button)findViewById(R.id.sensor_kamera_button_foto);
                    KameraButton.setEnabled(true);
                }
                mStartPlaying = !mStartPlaying;
            }
        });
    }

    public void onPause()
    {
        super.onPause();
        if (mRecorder != null)
        {
            mRecorder.release();
            mRecorder = null;
        }
        if (mPlayer != null)
        {
            mPlayer.release();
            mPlayer = null;
        }
    }

    private void onRecord(boolean start)
    {
        if (start == true) //Aufnahme starten
        {
            mFileName = Environment.getExternalStorageDirectory().getAbsolutePath();
            mFileName = mFileName + "/DCIM/" + Uhrzeit().toString() + "_Aufnahme" + getString(R.string.app_name) + ".3gp";

            mRecorder = new MediaRecorder();
            mRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
            mRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
            mRecorder.setOutputFile(mFileName);
            mRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
            try
            {
                mRecorder.prepare();
            }
            catch (IOException e){}

            mRecorder.start();
        }
        else // Aufnahme stoppen
        {
            mRecorder.stop();
            mRecorder.release();
            mRecorder = null;
        }
    }

    private void onPlay(boolean start)
    {
        if (start == true) // Wiedergabe starten
        {
            mPlayer = new MediaPlayer();
            try
            {
                mPlayer.setDataSource(mFileName);
                mPlayer.prepare();
                mPlayer.start();
            }
            catch (IOException e){}
        }
        else // Wiedergabe stoppen
        {
            mPlayer.release();
            mPlayer = null;
        }
    }

    //- Menü

	public boolean onCreateOptionsMenu(Menu menu)
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
