package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.animation.Animation;
import android.view.animation.RotateAnimation;
import android.widget.ImageView;
import android.widget.TextView;

public class SensorActivity_Kompass extends ActionBarActivity implements SensorEventListener
{
	// Steuerelementvariablen anlegen
    private ImageView
			image_sensor_kompass = null;

	private float
			Gradzahl = 0f;

	private SensorManager
			KompassSensorManager = null;

	private TextView
			text_sensor_kompass_gradzahl = null;

	private Sensor
			sensor_Kompass = null;

	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_kompass);                                           // Layout starten

		image_sensor_kompass = (ImageView) findViewById(R.id.sensor_kompass_image_kompass);         // Kompassbild was gedreht wird
		text_sensor_kompass_gradzahl = (TextView) findViewById(R.id.sensor_kompass_text_gradzahl);  // Anzeigen der Gradzahl
		KompassSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);            // SensorManager anlegen
		sensor_Kompass = KompassSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION);            // Orientierungssensor im System registrieren
	}

	public void onSensorChanged(SensorEvent event)                                                  // Wenn sichd er Sensorwert ändert
	{
		float grad = Math.round(event.values[0]);                                                   // Gradzahl runden

		text_sensor_kompass_gradzahl.setText(Float.toString(grad) + " " + getString(R.string.sensor_kompass_grad_einheit));                     // Gradzahl anzeigen

		RotateAnimation ra = new RotateAnimation                                                    // Bild um diese Gradzahl drehen
		(
			Gradzahl,
			-grad,
			Animation.RELATIVE_TO_SELF,
			0.5f,
			Animation.RELATIVE_TO_SELF,
			0.5f
		);

		// Wie lange die Animation läuft
		ra.setDuration(210);

		// Animation cachen + reservieren (geht gleich los)
		ra.setFillAfter(true);

		// Animation starten
		image_sensor_kompass.startAnimation(ra);
		Gradzahl = -grad;
	}

	protected void onResume()                                                                       // Wenn die App wieder gestartet wird
	{
		super.onResume();
		KompassSensorManager.registerListener(this, sensor_Kompass, SensorManager.SENSOR_DELAY_GAME);   // Orientierungssensor wieder starten und auf erhöte Empfindlichkeit einstellen -> läuft ruckelfreier
	}

	protected void onPause()                                                                        // Wenn die App minimiert wird
	{
		super.onPause();
		KompassSensorManager.unregisterListener(this);
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy){}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Menü anlegen
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
