package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import java.util.List;

public class SensorActivity_Sensoruebersicht extends ActionBarActivity
{
    // SensorListe Variable
    List<Sensor> SensorenListe = null;

	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_sensoruebersicht);                                  // Layout starten

		SensorAbfrage();                                                                            // Sensorabfrage durchführen
	}


	private void SensorAbfrage()
	{
		SensorManager mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);    // Sensormanager registrieren
		SensorenListe = mSensorManager.getSensorList(Sensor.TYPE_ALL);                              // Sensorliste erstellen lassen

		StringBuilder sensorInfo = new StringBuilder();                                             // Aus der Liste einen String bauen

		for (Sensor s : SensorenListe)                                                              // Sensorliste durchgehen
		{
			String str = s.getName() + "\n\t\t\t-> "+getString(R.string.sensor_uebersicht_text_strom) + " " + s.getPower() + " " + getString(R.string.sensor_uebersicht_text_strom_einheit);     // Name und Strom hintereinander hängen
			sensorInfo.append(str + "\n");                                                          // Leerzeile danach
		}
		TextView text_sensor_uebersicht_infos = (TextView) this.findViewById(R.id.sensor_uebersicht_text_infos);
		text_sensor_uebersicht_infos.setText(sensorInfo.toString());                                // String ausgeben -> Ergibt eine Liste
	}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Menü anlegen
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
