package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ImageView;
import android.widget.TextView;

public class SensorActivity_Spezial extends ActionBarActivity implements SensorEventListener
{
	private int AktuellerSensor = -1;

	private float[]
			Sensorwerte_neu = null, Sensorwerte_alt = {0,0,0}, Sensorwerte_differenz = {0,0,0};

	private	SensorManager
			SpezialSensorManager = null;

	private Sensor
			sensor_Gravitation = null, sensor_Gyroskop = null,
			sensor_MagFeld = null, sensor_RotationsVektor = null;

	private TextView
			text_sensor_spezial_wert_x = null, text_sensor_spezial_wert_y = null,
			text_sensor_spezial_wert_z = null, text_sensor_spezial_beschreibung = null,
			text_sensor_spezial_ueberschrift = null, text_sensor_spezial_hinweis = null;

	private ImageView
			image_sensor_koordinatensystem = null;

    // Schwellenwerte für die Erschütterungserkennung
	private float SENSORWERTE_SCHWELLE_gyro = (float)0.2;
	private float SENSORWERTE_SCHWELLE_rot = (float)0.05;
	private float SENSORWERTE_SCHWELLE_grav = (float)0.2;
	private float SENSORWERTE_SCHWELLE_magFeld = (float)1;


	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_spezial);                                           // Layout starten

		Intent intent = getIntent();
		String message = intent.getStringExtra(MenueActivity.EXTRA_MESSAGE);                        // Aus der Übergabe beim Starten der Activity schauen welcher Sensor angezeigt werden soll

		SpezialSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);            // SensorManager registrieren
		Sensorauswahl(Integer.valueOf(message));                                                    // Je nachdem welcher Sensor angezeigt werden soll -> Texte setzen
	}
	private void Sensorauswahl(int Auswahl)
	{
		text_sensor_spezial_ueberschrift = (TextView)findViewById(R.id.sensor_spezial_text_ueberschrift);   // Steuerelemente den Variablen zuordnen
		image_sensor_koordinatensystem = (ImageView)findViewById(R.id.sensor_spezial_image_koordinatensystem);
		text_sensor_spezial_beschreibung = (TextView)findViewById(R.id.sensor_spezial_text_beschreibung);
		text_sensor_spezial_wert_x = (TextView)findViewById(R.id.sensor_spezial_text_x);
		text_sensor_spezial_wert_y = (TextView)findViewById(R.id.sensor_spezial_text_y);
		text_sensor_spezial_wert_z = (TextView)findViewById(R.id.sensor_spezial_text_z);
		text_sensor_spezial_hinweis = (TextView)findViewById(R.id.sensor_spezial_text_hinweis);

		switch(Auswahl)                                                                             // Spezifische Texte setzen
		{
			case 3: Gyroskop(); break;
			case 4: RotationsVektor(); break;
			case 6: Gravitation(); break;
			case 7: MagFeld(); break;
		}
	}

	private void Gyroskop()
	{
		AktuellerSensor = 3;                                                                        // Sensornummer eintragen
		sensor_Gyroskop = SpezialSensorManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE);             // Sensor registrieren
		text_sensor_spezial_ueberschrift.setText(this.getString(R.string.menue_button_gyroskop_text));                                       // Texte setzen
		text_sensor_spezial_beschreibung.setText(R.string.sensor_spezial_text_beschreibung_gyroskop);
		image_sensor_koordinatensystem.setImageResource(R.drawable.koordinatensystemgyroskop);      // Koordinatensystem einfügen
	}
	private void RotationsVektor()
	{
		AktuellerSensor = 4;
		sensor_RotationsVektor = SpezialSensorManager.getDefaultSensor(Sensor.TYPE_ROTATION_VECTOR);    // Sensor registrieren
		text_sensor_spezial_ueberschrift.setText(this.getString(R.string.menue_button_rotationsvektor_text));
		text_sensor_spezial_beschreibung.setText(R.string.sensor_spezial_text_beschreibung_RotVektor);
		text_sensor_spezial_hinweis.setText(R.string.sensor_spezial_text_hinweis_RotVektor);
	}
	private void Gravitation()
	{
		AktuellerSensor = 6;
		sensor_Gravitation = SpezialSensorManager.getDefaultSensor(Sensor.TYPE_GRAVITY);            // Sensor registrieren
		text_sensor_spezial_ueberschrift.setText(this.getString(R.string.menue_button_gravitation_text));
		text_sensor_spezial_beschreibung.setText(R.string.sensor_spezial_text_beschreibung_gravitation);
		image_sensor_koordinatensystem.setImageResource(R.drawable.koordinatensystem);
	}
	private void MagFeld()
	{
		AktuellerSensor = 7;
		sensor_MagFeld = SpezialSensorManager.getDefaultSensor(Sensor.TYPE_MAGNETIC_FIELD);         // Sensor registrieren
		text_sensor_spezial_ueberschrift.setText(this.getString(R.string.sensor_spezial_magFeld_text));
		text_sensor_spezial_beschreibung.setText(R.string.sensor_spezial_text_beschreibung_magFeld);
		image_sensor_koordinatensystem.setImageResource(R.drawable.koordinatensystem);
	}

	public void onSensorChanged(SensorEvent event)                                                  // Wenn sich ein Sensorwert ändert
	{
		switch(AktuellerSensor)                                                                     // Schauen welcher Sensor es war
		{
			case 3:
				if(event.sensor == sensor_Gyroskop)                                                 // Der richtige Sensor?
				{
					Sensorwerte_neu = null;
					Sensorwerte_neu = event.values.clone();                                         // Sensorwert auslesen

					for(int i=0; i<=2; i++)                                                         // Differenz bilden
					{
						Sensorwerte_differenz[i] = Sensorwerte_alt[i] - Sensorwerte_neu[i];         // Differenz ausrechnen
						if(Sensorwerte_differenz[i] < 0){Sensorwerte_differenz[i]=Sensorwerte_differenz[i]*(-1);}   // Betrag nehmen
					}

					if(Sensorwerte_differenz[0] > SENSORWERTE_SCHWELLE_gyro){text_sensor_spezial_wert_x.setTextColor(Color.RED);}   // Wenn eine Erschütterung festgestellt wurde -> Rot markieren
					else{text_sensor_spezial_wert_x.setTextColor(Color.WHITE);}                     // Sonst weiß lassen
					if(Sensorwerte_differenz[1] > SENSORWERTE_SCHWELLE_gyro){text_sensor_spezial_wert_y.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_y.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[2] > SENSORWERTE_SCHWELLE_gyro){text_sensor_spezial_wert_z.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_z.setTextColor(Color.WHITE);}

					text_sensor_spezial_wert_x.setText(getString(R.string.sensor_spezial_in_x) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[0],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));   // Werte eintragen
					text_sensor_spezial_wert_y.setText(getString(R.string.sensor_spezial_in_y) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[1],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));
					text_sensor_spezial_wert_z.setText(getString(R.string.sensor_spezial_in_z) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[2],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));

					Sensorwerte_alt = Sensorwerte_neu;                                              // Sensorwerte merken für die nächste Differenzberechnung
				}break;

			case 4:
				if(event.sensor == sensor_RotationsVektor)                                          // siehe oben
				{
					Sensorwerte_neu = null;
					Sensorwerte_neu = event.values.clone();

					for(int i=0; i<=2; i++)
					{
						Sensorwerte_differenz[i] = Sensorwerte_alt[i] - Sensorwerte_neu[i];
						if(Sensorwerte_differenz[i] < 0){Sensorwerte_differenz[i]=Sensorwerte_differenz[i]*(-1);}
					}
					if(Sensorwerte_differenz[0] > SENSORWERTE_SCHWELLE_rot){text_sensor_spezial_wert_x.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_x.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[1] > SENSORWERTE_SCHWELLE_rot){text_sensor_spezial_wert_y.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_y.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[2] > SENSORWERTE_SCHWELLE_rot){text_sensor_spezial_wert_z.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_z.setTextColor(Color.WHITE);}

					text_sensor_spezial_wert_x.setText(getString(R.string.sensor_spezial_in_x) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[0],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));
					text_sensor_spezial_wert_y.setText(getString(R.string.sensor_spezial_in_y) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[1],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));
					text_sensor_spezial_wert_z.setText(getString(R.string.sensor_spezial_in_z) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[2],3)) + " " + getString(R.string.sensor_spezial_rad_einheit));

					Sensorwerte_alt = Sensorwerte_neu;
				}break;

			case 6:
				if(event.sensor == sensor_Gravitation)                                              // siehe oben
				{
					Sensorwerte_neu = null;
					Sensorwerte_neu = event.values.clone();

					for(int i=0; i<=2; i++)
					{
						Sensorwerte_differenz[i] = Sensorwerte_alt[i] - Sensorwerte_neu[i];
						if(Sensorwerte_differenz[i] < 0){Sensorwerte_differenz[i]=Sensorwerte_differenz[i]*(-1);}
					}

					if(Sensorwerte_differenz[0] > SENSORWERTE_SCHWELLE_grav){text_sensor_spezial_wert_x.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_x.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[1] > SENSORWERTE_SCHWELLE_grav){text_sensor_spezial_wert_y.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_y.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[2] > SENSORWERTE_SCHWELLE_grav){text_sensor_spezial_wert_z.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_z.setTextColor(Color.WHITE);}

					text_sensor_spezial_wert_x.setText(getString(R.string.sensor_spezial_in_x) + " " + String.valueOf(FloatRunden((-1)*Sensorwerte_neu[0],3)) + " " + getString(R.string.sensor_spezial_beschleunigung_einheit));
					text_sensor_spezial_wert_y.setText(getString(R.string.sensor_spezial_in_y) + " " + String.valueOf(FloatRunden((-1)*Sensorwerte_neu[1],3)) + " " + getString(R.string.sensor_spezial_beschleunigung_einheit));
					text_sensor_spezial_wert_z.setText(getString(R.string.sensor_spezial_in_z) + " " + String.valueOf(FloatRunden((-1)*Sensorwerte_neu[2],3)) + " " + getString(R.string.sensor_spezial_beschleunigung_einheit));

					Sensorwerte_alt = Sensorwerte_neu;
				}break;

			case 7:
				if(event.sensor == sensor_MagFeld)                                                  // siehe oben
				{
					Sensorwerte_neu = null;
					Sensorwerte_neu = event.values.clone();

					for(int i=0; i<=2; i++)
					{
						Sensorwerte_differenz[i] = Sensorwerte_alt[i] - Sensorwerte_neu[i];
						if(Sensorwerte_differenz[i] < 0){Sensorwerte_differenz[i]=Sensorwerte_differenz[i]*(-1);}
					}

					if(Sensorwerte_differenz[0] > SENSORWERTE_SCHWELLE_magFeld){text_sensor_spezial_wert_x.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_x.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[1] > SENSORWERTE_SCHWELLE_magFeld){text_sensor_spezial_wert_y.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_y.setTextColor(Color.WHITE);}
					if(Sensorwerte_differenz[2] > SENSORWERTE_SCHWELLE_magFeld){text_sensor_spezial_wert_z.setTextColor(Color.RED);}
					else{text_sensor_spezial_wert_z.setTextColor(Color.WHITE);}

					text_sensor_spezial_wert_x.setText(getString(R.string.sensor_spezial_in_x) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[0],3)) + " " + getString(R.string.sensor_spezial_magFeld_einheit));
					text_sensor_spezial_wert_y.setText(getString(R.string.sensor_spezial_in_y) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[1],3)) + " " + getString(R.string.sensor_spezial_magFeld_einheit));
					text_sensor_spezial_wert_z.setText(getString(R.string.sensor_spezial_in_z) + " " + String.valueOf(FloatRunden(Sensorwerte_neu[2],3)) + " " + getString(R.string.sensor_spezial_magFeld_einheit));

					Sensorwerte_alt = Sensorwerte_neu;
				}break;
		}
	}

	protected void onPause()                                                                        // Wenn die App minimiert wird
	{
		super.onPause();
		SpezialSensorManager.unregisterListener(this);                                              // SensorManager deaktivieren
	}

	protected void onResume()                                                                       // Wenn die App dann wieder gestartet wird
	{
		super.onResume();

		switch(AktuellerSensor)                                                                     // Passenden Sensor wieder eintragen
		{
			case 3: SpezialSensorManager.registerListener(this, sensor_Gyroskop,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 4: SpezialSensorManager.registerListener(this, sensor_RotationsVektor,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 6: SpezialSensorManager.registerListener(this, sensor_Gravitation,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 7: SpezialSensorManager.registerListener(this, sensor_MagFeld,SensorManager.SENSOR_DELAY_NORMAL); break;
		}
	}

	public static double FloatRunden(double wert, int stellen)                                      // Wert runden
	{
		double gerundet = Math.round(wert * Math.pow(10d, stellen));
		return gerundet / Math.pow(10d, stellen);
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Menü anlegen
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}
