package com.tuhh.mikrosystem.handysensoren;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class SensorActivity_Standard extends ActionBarActivity implements SensorEventListener
{
	private SensorManager
			mSensorManager = null;

	private int
			AktuellerSensor = -1;

	private float[]
			Sensorwerte = null;

	private Sensor
			sensor_Geraetetemperatur = null, sensor_Licht = null, sensor_Luftdruck = null,
			sensor_Naeherung = null, sensor_Puls = null, sensor_RelFeuchtigkeit = null,
			sensor_Umgebungstemperatur = null;

	private TextView
		text_sensor_standard_ueberschrift = null, text_sensor_standard_wert = null,
		text_sensor_standard_einheit = null, text_sensor_standard_hinweis = null,
		text_sensor_standard_sonstiges = null;

	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_standard);                                          // Layout starten

		Intent intent = getIntent();
		String message = intent.getStringExtra(MenueActivity.EXTRA_MESSAGE);                        // Bei der Übergabe in die Funktion wird ein Wert mitgeliefert, der angibt, welcher Sensor jetzt angezeigt und abgefragt werden soll

		mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);                  // SensorManager anlegen
		Sensorauswahl(Integer.valueOf(message));                                                    // Je nach Sensor spezifische Texte anzeigen
	}

	private void Sensorauswahl(int Auswahl)
	{
		text_sensor_standard_ueberschrift = (TextView)findViewById(R.id.sensor_standard_text_ueberschrift);     // Steuerelementvariablen füllen
		text_sensor_standard_wert = (TextView)findViewById(R.id.sensor_standard_text_wert);
		text_sensor_standard_einheit = (TextView)findViewById(R.id.sensor_standard_text_einheit);
		text_sensor_standard_hinweis = (TextView)findViewById(R.id.sensor_standard_text_hinweis);
		text_sensor_standard_sonstiges = (TextView)findViewById(R.id.sensor_standard_text_sonstiges);

		switch(Auswahl)                                                                             // Je nach Sensor die richtigen Texte anzeigen
		{
			case 8: Naeherung(); break;
			case 9: Temperatur(); break;
			case 10: Luftdruck(); break;
			case 11: RelFeuchtigkeit(); break;
			case 12: Licht(); break;
			case 13: Umgebungstemperatur(); break;
			case 15: Puls(); break;
            case 18: Umgebungstemperatur(); break;
            case 19: Geraetetemperatur(); break;
		}
	}

    private void Temperatur()                                                                       // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
    {                                                                                               // Wenn beide Temperatursensoren eingebaut sind -> Werden auch beide angezeigt
        AktuellerSensor = 9;
        sensor_Geraetetemperatur = mSensorManager.getDefaultSensor(Sensor.TYPE_TEMPERATURE);
        sensor_Umgebungstemperatur = mSensorManager.getDefaultSensor(Sensor.TYPE_AMBIENT_TEMPERATURE);
        text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_temperatur_text));

        TextView text_sensor_messwert = (TextView)findViewById(R.id.sensor_standard_text_messwert);
        text_sensor_messwert.setText(R.string.menue_button_geraetetemperatur_text);

        TextView text_sensor_messwert_zusatz = (TextView)findViewById(R.id.sensor_standard_text_messwert_zusatz);
        text_sensor_messwert_zusatz.setText(R.string.menue_button_umgebungstemperatur_text);
        text_sensor_messwert_zusatz.setVisibility(View.VISIBLE);                                    // Zusätzliche, normal unsichtbare, Textfelder sichtbar machen (es werden ja zwei Sensoren engezeigt und nicht wie üblich nur einer)

        TextView text_sensor_standard_wert_zusatz = (TextView)findViewById(R.id.sensor_standard_text_wert_zusatz);
        TextView text_sensor_standard_einheit_zusatz = (TextView)findViewById(R.id.sensor_standard_text_einheit_zusatz);
        text_sensor_standard_wert_zusatz.setVisibility(View.VISIBLE);
        text_sensor_standard_einheit_zusatz.setVisibility(View.VISIBLE);

    }

	private void Naeherung()                                                                        // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 8;
		sensor_Naeherung = mSensorManager.getDefaultSensor(Sensor.TYPE_PROXIMITY);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_naeherung_text));
	}
	private void Geraetetemperatur()                                                                // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 19;
		sensor_Geraetetemperatur = mSensorManager.getDefaultSensor(Sensor.TYPE_TEMPERATURE);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_geraetetemperatur_text));
	}
	private void Luftdruck()                                                                        // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 10;
		sensor_Luftdruck = mSensorManager.getDefaultSensor(Sensor.TYPE_PRESSURE);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_luftdruck_text));
	}
	private void RelFeuchtigkeit()                                                                  // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 11;
		sensor_RelFeuchtigkeit = mSensorManager.getDefaultSensor(Sensor.TYPE_RELATIVE_HUMIDITY);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_relFeuchtigkeit_text));
	}
	private void Licht()                                                                            // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 12;
		sensor_Licht = mSensorManager.getDefaultSensor(Sensor.TYPE_LIGHT);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_licht_text));
	}
	private void Umgebungstemperatur()                                                              // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor = 18;
		sensor_Umgebungstemperatur = mSensorManager.getDefaultSensor(Sensor.TYPE_AMBIENT_TEMPERATURE);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_umgebungstemperatur_text));
	}
	private void Puls()                                                                             // Sensornummer setzen, Sensor registrieren sodass Events ausgelöst werden und die passende Überschrift setzen
	{
		AktuellerSensor=15;
		sensor_Puls = mSensorManager.getDefaultSensor(Sensor.TYPE_HEART_RATE);
		text_sensor_standard_ueberschrift.setText(this.getString(R.string.menue_button_puls_text));
	}

	public void onSensorChanged(SensorEvent event)                                                  // Es ist ein neuer Wert eingegangen
	{
		switch(AktuellerSensor)                                                                     // Welcher Sensor muss geupdatet werden?
		{
			case 8:
				if(event.sensor == sensor_Naeherung)                                                // Näherungssensor hat sich geändert
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();                                             // Sensorwerte kopieren

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));              // Wert ausgeben
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_naeherung);                                     // Einheit dahintersetzen
					text_sensor_standard_hinweis.setText(R.string.sensor_standard_text_hinweis_naeherung);  // Zusatztext (optional)

					if(Sensorwerte[0] < 5){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_nah);}         // Entscheiden was damit angezeigt wird
					else{text_sensor_standard_sonstiges.setText(R.string.sensor_standard_fern);}
				}break;

			case 19:
				if(event.sensor == sensor_Geraetetemperatur)                                        // siehe oben
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_temperatur);

					if(Sensorwerte[0] <= 0){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur1);}
					else if(Sensorwerte[0] <= 20) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur2);}
					else if(Sensorwerte[0] <= 40) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur3);}
					else if(Sensorwerte[0] > 40) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur4);}
				}break;

			case 10:
				if(event.sensor == sensor_Luftdruck)                                                // siehe oben
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_luftdruck);
				}break;

			case 11:
				if(event.sensor == sensor_RelFeuchtigkeit)                                          // siehe oben
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_relFeuchtigkeit);
				}break;

			case 12:                                                                                // siehe oben
				if(event.sensor == sensor_Licht)
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_licht);

					if(Sensorwerte[0] <= 50){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Helligkeit1);}
					else if(Sensorwerte[0] <= 100){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Helligkeit2);}
					else if(Sensorwerte[0] <= 200){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Helligkeit3);}
					else if((Sensorwerte[0] > 200) && (Sensorwerte[0] <= 1000)){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Helligkeit4);}
					else if(Sensorwerte[0] > 1000){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Helligkeit5);}
				}break;

			case 18:
				if(event.sensor == sensor_Umgebungstemperatur)                                      // siehe oben
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_temperatur);

					if(Sensorwerte[0] <= 0){text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur1);}
					else if(Sensorwerte[0] <= 10) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur2);}
					else if(Sensorwerte[0] <= 25) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur3);}
					else if(Sensorwerte[0] > 25) {text_sensor_standard_sonstiges.setText(R.string.sensor_standard_Temperatur4);}
				}break;

			case 15:
				if(event.sensor == sensor_Puls)                                                     // siehe oben
				{
					Sensorwerte = null;
					Sensorwerte = event.values.clone();

					text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
					text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_puls);
				}break;

            case 9:
                if(event.sensor == sensor_Geraetetemperatur)                                        // siehe oben
                {
                    Sensorwerte = null;
                    Sensorwerte = event.values.clone();

                    text_sensor_standard_wert.setText(String.valueOf(Sensorwerte[0]));
                    text_sensor_standard_einheit.setText(R.string.sensor_standard_einheit_temperatur);
                }
                if(event.sensor == sensor_Umgebungstemperatur)                                      // siehe oben
                {
                    Sensorwerte = null;
                    Sensorwerte = event.values.clone();

                    TextView text_sensor_standard_wert_zusatz = (TextView)findViewById(R.id.sensor_standard_text_wert_zusatz);
                    TextView text_sensor_standard_einheit_zusatz = (TextView)findViewById(R.id.sensor_standard_text_einheit_zusatz);
                    text_sensor_standard_wert_zusatz.setText(String.valueOf(Sensorwerte[0]));
                    text_sensor_standard_einheit_zusatz.setText(R.string.sensor_standard_einheit_temperatur);
                }
                break;
		}
	}
	protected void onPause()                                                                        // Wenn die App minimiert wird
	{
		super.onPause();
		mSensorManager.unregisterListener(this);                                                    // SensorManager deaktivieren
	}
	protected void onResume()                                                                       // Wenn die App dann wieder geöffnet wird
	{
		super.onResume();

		switch(AktuellerSensor)                                                                     // Je nach Sensor den/die passende/n Sensor/en wieder aktivieren
		{
			case 8: mSensorManager.registerListener(this, sensor_Naeherung,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 9: mSensorManager.registerListener(this, sensor_Geraetetemperatur,SensorManager.SENSOR_DELAY_NORMAL);
                    mSensorManager.registerListener(this, sensor_Umgebungstemperatur, SensorManager.SENSOR_DELAY_NORMAL); break;
			case 19: mSensorManager.registerListener(this, sensor_Geraetetemperatur,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 10: mSensorManager.registerListener(this, sensor_Luftdruck,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 11: mSensorManager.registerListener(this, sensor_RelFeuchtigkeit,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 12: mSensorManager.registerListener(this, sensor_Licht,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 18: mSensorManager.registerListener(this, sensor_Umgebungstemperatur,SensorManager.SENSOR_DELAY_NORMAL); break;
			case 15: mSensorManager.registerListener(this, sensor_Puls,SensorManager.SENSOR_DELAY_NORMAL); break;
		}
	}
	public void onAccuracyChanged(Sensor sensor, int accuracy) {}

	public boolean onCreateOptionsMenu(Menu menu)                                                   // Menü anlegen
	{
		getMenuInflater().inflate(R.menu.menu_klein, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.action_info:
				Info();
				return true;

			default:
				return super.onOptionsItemSelected(item);
		}
	}

	private void Info()
	{
		AlertDialog alertDialog = new AlertDialog.Builder(this).create();
		alertDialog.setTitle("INFO");
		alertDialog.setMessage(getString(R.string.menue_info_text));
		alertDialog.setButton("OK", new DialogInterface.OnClickListener()
		{public void onClick(DialogInterface dialog, int which) {}});
		alertDialog.show();
	}
}

